
-- Roll Frames start here
function DOKarma:SetupFrames()
	local f, t, sframe, i, j

	f, _, _ = GameFontNormal:GetFont()

	self.frames = {}

	self.frames.main = CreateFrame("Frame", "DOKarmaRollFrame", UIParent)
	self.frames.main:Hide()
	self.frames.main:SetWidth(325)
	self.frames.main:SetHeight(440)
	self.frames.main:EnableMouse(true)
	self.frames.main:SetMovable(true)
	self.frames.main:RegisterForDrag("LeftButton")
	self.frames.main:SetScript("OnDragStart", function() this:StartMoving() end)
	self.frames.main:SetScript("OnDragStop", function() this:StopMovingOrSizing() end)
	self.frames.main:SetBackdrop({
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", tile = true, tileSize = 16,
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16,
		insets = {left = 4, right = 4, top = 4, bottom = 4},
		})
	self.frames.main:SetBackdropBorderColor(.5, .5, .5)
	self.frames.main:SetBackdropColor(0,0,0)
	self.frames.main:ClearAllPoints()
	self.frames.main:SetPoint("CENTER", WorldFrame, "CENTER", 0, 0)

	self.frames.fade = self.frames.main:CreateTexture(nil, "BORDER")
	self.frames.fade:SetWidth(319)
	self.frames.fade:SetHeight(25)
	self.frames.fade:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.frames.fade:SetPoint("TOP", self.frames.main, "TOP", 0, -4)
	self.frames.fade:SetBlendMode("ADD")
	self.frames.fade:SetGradientAlpha("VERTICAL", .1, .1, .1, 0, .25, .25, .25, 1)
	self.frames.main.Fade = self.frames.fade

	self.frames.header = self.frames.main:CreateFontString(nil,"OVERLAY")
	self.frames.header:SetFont(f, 14)
	self.frames.header:SetWidth(350)
	self.frames.header:SetText("Karma Rolls")
	self.frames.header:SetTextColor(1, .8, 0)
	self.frames.header:ClearAllPoints()
	self.frames.header:SetPoint("TOP", self.frames.main, "TOP", 0, -10)

	self.frames.headername = CreateFrame("Button", nil, self.frames.main)
	self.frames.headername.owner = self
	self.frames.headername:SetWidth(150)
	self.frames.headername:SetHeight(16)
	self.frames.headername:SetPoint("TOPLEFT", self.frames.main, "TOPLEFT", 10, -35)
	self.frames.headername:SetScript("OnClick",
			function()
				this.owner:Sort(self.KarmaRolls, 1)
				this.owner:UpdateScrollBar()
			end)

	self.frames.headernamehigh = self.frames.headername:CreateTexture(nil, "BORDER")
	self.frames.headernamehigh:SetWidth(150)
	self.frames.headernamehigh:SetHeight(16)
	self.frames.headernamehigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.frames.headernamehigh:SetAllPoints(self.frames.headername)
	self.frames.headernamehigh:SetBlendMode("ADD")
	self.frames.headernamehigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	self.frames.headername:SetHighlightTexture(self.frames.headernamehigh)

	self.frames.headernametext = self.frames.headername:CreateFontString(nil,"OVERLAY")
	self.frames.headernametext.owner = self
	self.frames.headernametext:SetFont(f, 14)
	self.frames.headernametext:SetWidth(150)
	self.frames.headernametext:SetText("Name")
	self.frames.headernametext:SetTextColor(1, .8, 0)
	self.frames.headernametext:ClearAllPoints()
	self.frames.headernametext:SetJustifyH("LEFT")
	self.frames.headernametext:SetAllPoints(self.frames.headername)

	self.frames.headerroll = CreateFrame("Button", nil, self.frames.main)
	self.frames.headerroll.owner = self
	self.frames.headerroll:SetWidth(50)
	self.frames.headerroll:SetHeight(16)
	self.frames.headerroll:SetPoint("LEFT", self.frames.headername, "RIGHT")
	self.frames.headerroll:SetScript("OnClick",
			function()
				this.owner:Sort(self.KarmaRolls, 2)
				this.owner:UpdateScrollBar()
			end)

	self.frames.headerrollhigh = self.frames.headerroll:CreateTexture(nil, "BORDER")
	self.frames.headerrollhigh:SetWidth(50)
	self.frames.headerrollhigh:SetHeight(16)
	self.frames.headerrollhigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.frames.headerrollhigh:SetAllPoints(self.frames.headerroll)
	self.frames.headerrollhigh:SetBlendMode("ADD")
	self.frames.headerrollhigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	self.frames.headerroll:SetHighlightTexture(self.frames.headerrollhigh)

	self.frames.headerrolltext = self.frames.main:CreateFontString(nil,"OVERLAY")
	self.frames.headerrolltext:SetFont(f, 14)
	self.frames.headerrolltext:SetWidth(50)
	self.frames.headerrolltext:SetText("Roll")
	self.frames.headerrolltext:SetTextColor(1, .8, 0)
	self.frames.headerrolltext:ClearAllPoints()
	self.frames.headerrolltext:SetJustifyH("LEFT")
	self.frames.headerrolltext:SetAllPoints(self.frames.headerroll)

	self.frames.headertotal = CreateFrame("Button", nil, self.frames.main)
	self.frames.headertotal.owner = self
	self.frames.headertotal:SetWidth(80)
	self.frames.headertotal:SetHeight(16)
	self.frames.headertotal:SetPoint("LEFT", self.frames.headerroll, "RIGHT")
	self.frames.headertotal:SetScript("OnClick",
			function()
				this.owner:Sort(self.KarmaRolls, 3)
				this.owner:UpdateScrollBar()
			end)

	self.frames.headertotalhigh = self.frames.headertotal:CreateTexture(nil, "BORDER")
	self.frames.headertotalhigh:SetWidth(80)
	self.frames.headertotalhigh:SetHeight(16)
	self.frames.headertotalhigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.frames.headertotalhigh:SetAllPoints(self.frames.headertotal)
	self.frames.headertotalhigh:SetBlendMode("ADD")
	self.frames.headertotalhigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	self.frames.headertotal:SetHighlightTexture(self.frames.headertotalhigh)

	self.frames.headertotaltext = self.frames.main:CreateFontString(nil,"OVERLAY")
	self.frames.headertotaltext.owner = self
	self.frames.headertotaltext:SetFont(f, 14)
	self.frames.headertotaltext:SetWidth(80)
	self.frames.headertotaltext:SetText("Total Roll")
	self.frames.headertotaltext:SetTextColor(1, .8, 0)
	self.frames.headertotaltext:ClearAllPoints()
	self.frames.headertotaltext:SetJustifyH("LEFT")
	self.frames.headertotaltext:SetAllPoints(self.frames.headertotal)

	--Roll Button
	self.frames.rollbutton = CreateFrame("Button", nil, self.frames.main)
	self.frames.rollbutton.owner = self
	self.frames.rollbutton:SetWidth(60)
	self.frames.rollbutton:SetHeight(32)
 	self.frames.rollbutton:SetPoint("BOTTOMLEFT", self.frames.main, "BOTTOM", -150, 10)
	
	t = self.frames.rollbutton:CreateTexture()
	t:SetWidth(60)
	t:SetHeight(32)
	t:SetPoint("CENTER", self.frames.rollbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	self.frames.rollbutton:SetNormalTexture(t)

	t = self.frames.rollbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.frames.rollbutton)
	self.frames.rollbutton:SetPushedTexture(t)
	
	t = self.frames.rollbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.frames.rollbutton)
	t:SetBlendMode("ADD")
	self.frames.rollbutton:SetHighlightTexture(t)
	self.frames.rollbuttontext = self.frames.rollbutton:CreateFontString(nil,"OVERLAY")
	self.frames.rollbuttontext:SetFontObject(GameFontHighlight)
	self.frames.rollbuttontext:SetText("Roll")
	self.frames.rollbuttontext:SetAllPoints(self.frames.rollbutton)

	self.frames.rollbutton:SetScript("OnClick",
			function()
				this.owner.frames.rollbutton:Hide()
				this.owner.frames.passbutton:Hide()
				RandomRoll(1, 100)
			end)

	--Pass Button
	self.frames.passbutton = CreateFrame("Button", nil, self.frames.main)
	self.frames.passbutton.owner = self
	self.frames.passbutton:SetWidth(60)
	self.frames.passbutton:SetHeight(32)
 	self.frames.passbutton:SetPoint("BOTTOMRIGHT", self.frames.main, "BOTTOM", -25, 10)
	
	t = self.frames.passbutton:CreateTexture()
	t:SetWidth(60)
	t:SetHeight(32)
	t:SetPoint("CENTER", self.frames.passbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	self.frames.passbutton:SetNormalTexture(t)

	t = self.frames.passbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.frames.passbutton)
	self.frames.passbutton:SetPushedTexture(t)
	
	t = self.frames.passbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.frames.passbutton)
	t:SetBlendMode("ADD")
	self.frames.passbutton:SetHighlightTexture(t)
	self.frames.passbuttontext = self.frames.passbutton:CreateFontString(nil,"OVERLAY")
	self.frames.passbuttontext:SetFontObject(GameFontHighlight)
	self.frames.passbuttontext:SetText("Pass")
	self.frames.passbuttontext:SetAllPoints(self.frames.passbutton)

	self.frames.passbutton:SetScript("OnClick",
			function()
				this.owner.frames.passbutton:Hide()
				this.owner.frames.rollbutton:Hide()
				self:PassOnRoll(self.Settings.LocalPlayer)
			end)

	--Not Rolled Button
	self.frames.nrbutton = CreateFrame("Button", nil, self.frames.main)
	self.frames.nrbutton.owner = self
	self.frames.nrbutton:SetWidth(40)
	self.frames.nrbutton:SetHeight(32)
 	self.frames.nrbutton:SetPoint("BOTTOMRIGHT", self.frames.main, "BOTTOM", 20, 10)
	
	t = self.frames.nrbutton:CreateTexture()
	t:SetWidth(40)
	t:SetHeight(32)
	t:SetPoint("CENTER", self.frames.nrbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	self.frames.nrbutton:SetNormalTexture(t)

	t = self.frames.nrbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.frames.nrbutton)
	self.frames.nrbutton:SetPushedTexture(t)
	
	t = self.frames.nrbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.frames.nrbutton)
	t:SetBlendMode("ADD")
	self.frames.nrbutton:SetHighlightTexture(t)
	self.frames.nrbuttontext = self.frames.nrbutton:CreateFontString(nil,"OVERLAY")
	self.frames.nrbuttontext:SetFontObject(GameFontHighlight)
	self.frames.nrbuttontext:SetText("NR")
	self.frames.nrbuttontext:SetAllPoints(self.frames.nrbutton)

	self.frames.nrbutton:SetScript("OnClick",
			function()
				self:NotRolled()
			end)

	--Reset Button
	self.frames.resetbutton = CreateFrame("Button", nil, self.frames.main)
	self.frames.resetbutton.owner = self
	self.frames.resetbutton:SetWidth(60)
	self.frames.resetbutton:SetHeight(32)
	self.frames.resetbutton:SetPoint("BOTTOMLEFT", self.frames.main, "BOTTOM", 25, 10)
	
	t = self.frames.resetbutton:CreateTexture()
	t:SetWidth(60)
	t:SetHeight(32)
	t:SetPoint("CENTER", self.frames.resetbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	self.frames.resetbutton:SetNormalTexture(t)

	t = self.frames.resetbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.frames.resetbutton)
	self.frames.resetbutton:SetPushedTexture(t)
	
	t = self.frames.resetbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.frames.resetbutton)
	t:SetBlendMode("ADD")
	self.frames.resetbutton:SetHighlightTexture(t)
	self.frames.resetbuttontext = self.frames.resetbutton:CreateFontString(nil,"OVERLAY")
	self.frames.resetbuttontext:SetFontObject(GameFontHighlight)
	self.frames.resetbuttontext:SetText("Reset")
	self.frames.resetbuttontext:SetAllPoints(self.frames.resetbutton)

	self.frames.resetbutton:SetScript("OnClick",
			function()
				self.Settings.IsActiveRoll = false
				self:SendCommMessage("RAID", "HideClientRollFrame")
				this.owner:PerformKarmaRollCheck()
				this.owner.frames.passbutton:Show()
				this.owner.frames.rollbutton:Show()
			end)
	
	--Close Button
	self.frames.closebutton = CreateFrame("Button", nil, self.frames.main)
	self.frames.closebutton.owner = self
	self.frames.closebutton:SetWidth(60)
	self.frames.closebutton:SetHeight(32)
	self.frames.closebutton:SetPoint("BOTTOMRIGHT", self.frames.main, "BOTTOM", 150, 10)
	
	t = self.frames.closebutton:CreateTexture()
	t:SetWidth(60)
	t:SetHeight(32)
	t:SetPoint("CENTER", self.frames.closebutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	self.frames.closebutton:SetNormalTexture(t)

	t = self.frames.closebutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.frames.closebutton)
	self.frames.closebutton:SetPushedTexture(t)
	
	t = self.frames.closebutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.frames.closebutton)
	t:SetBlendMode("ADD")
	self.frames.closebutton:SetHighlightTexture(t)
	self.frames.closebuttontext = self.frames.closebutton:CreateFontString(nil,"OVERLAY")
	self.frames.closebuttontext:SetFontObject(GameFontHighlight)
	self.frames.closebuttontext:SetText("Close")
	self.frames.closebuttontext:SetAllPoints(self.frames.closebutton)

	self.frames.closebutton:SetScript("OnClick",
			function()
				self.Settings.IsActiveRoll = false
				self:SendCommMessage("RAID", "HideClientRollFrame")
				this.owner.frames.main:Hide()
			end)

	self.frames.entry = {}
	self.frames.entry[1] = self:ScrollEntryFrame(1)
	self.frames.entry[1]:SetPoint("TOPLEFT", self.frames.main, "TOPLEFT", 10, -55 )
	
	for i=2, 20 do
		j = i - 1
		self.frames.entry[i] = self:ScrollEntryFrame()
		self.frames.entry[i]:SetPoint("TOPLEFT", self.frames.entry[j], "BOTTOMLEFT")
	end

	self.frames.sframe = CreateFrame("ScrollFrame", "DOKarmaRollScrollFrame", self.frames.main, "FauxScrollFrameTemplate")
	self.frames.sframe.owner = self
	self.frames.sframe:SetParent(self.frames.main)
	self.frames.sframe:SetWidth(285)
	self.frames.sframe:SetHeight(320)
	self.frames.sframe:SetPoint("TOPLEFT", self.frames.main, "TOPLEFT", 5, -55)

	self.frames.sframe:SetScript("OnVerticalScroll",
			function()
				FauxScrollFrame_OnVerticalScroll(16, function() this.owner:UpdateScrollBar() end)
			end )

end

function DOKarma:ScrollEntryFrame()
	local f = CreateFrame("Button", nil, self.frames.main )
	f:SetWidth(240)
	f:SetHeight(16)
	
	f:SetScript("OnClick",
		function()
			self:TestFrameClick(this.textname.NormalName)
		end)

	f.textname = f:CreateFontString(nil,"ARTWORK")
	f.textname:SetFontObject(GameFontHighlight)
	f.textname:SetWidth(150)
	f.textname:SetHeight(16)
	f.textname:SetJustifyH("LEFT")
	f.textname:SetNonSpaceWrap(false)
	f.textname:ClearAllPoints()
	f.textname:SetPoint( "LEFT", f, "LEFT")
	f.textname:SetTextColor(1,1,1)
	f.textname:SetText("Name")

	f.textroll = f:CreateFontString(nil,"ARTWORK")
	f.textroll:SetFontObject(GameFontHighlight)
	f.textroll:SetWidth(70)
	f.textroll:SetHeight(16)
	f.textroll:SetJustifyH("LEFT")
	f.textroll:SetNonSpaceWrap(false)
	f.textroll:ClearAllPoints()
	f.textroll:SetPoint("LEFT", f.textname, "RIGHT")
	f.textroll:SetTextColor(1,1,1)
	f.textroll:SetText("12%")

	f.texttotal = f:CreateFontString(nil,"ARTWORK")
	f.texttotal:SetFontObject(GameFontHighlight)
	f.texttotal:SetWidth(60)
	f.texttotal:SetHeight(16)
	f.texttotal:SetJustifyH("LEFT")
	f.texttotal:SetNonSpaceWrap(false)
	f.texttotal:ClearAllPoints()
	f.texttotal:SetPoint("LEFT", f.textroll, "RIGHT")
	f.texttotal:SetTextColor(1,1,1)
	f.texttotal:SetText("3")

	return f
end

function DOKarma:UpdateScrollBar()
	local i,j
	local entries = table.getn(self.KarmaRolls)
	FauxScrollFrame_Update(self.frames.sframe, entries, 20, 16)
	
	for i = 1, 20 do
		j = i + FauxScrollFrame_GetOffset(self.frames.sframe)

		if j <= entries then
			if self.KarmaRolls[j][6] == true then
				--self.frames.entry[i].textname:SetText(self.RollRoster[self.KarmaRolls[j][1]].ColouredPassNameString) --self.KarmaRolls[j][1])
				self.frames.entry[i].textname:SetText(self.KarmaRolls[j][4]) --self.KarmaRolls[j][1])
			else
				--self.frames.entry[i].textname:SetText(self.RollRoster[self.KarmaRolls[j][1]].ColouredNameString) --self.KarmaRolls[j][1])
				self.frames.entry[i].textname:SetText(self.KarmaRolls[j][4]) --self.KarmaRolls[j][1])
			end
			self.frames.entry[i].textname.NormalName = self.KarmaRolls[j][1]
			self.frames.entry[i].textroll:SetText(self.KarmaRolls[j][2])
			self.frames.entry[i].texttotal:SetText(self.KarmaRolls[j][3])
			self.frames.entry[i]:Show()
		else
			self.frames.entry[i]:Hide()
		end
	end

end

--Client Frames Start Here

function DOKarma:SetupClientFrames()
	local f, t, sframe, i, j

	f, _, _ = GameFontNormal:GetFont()

	self.clientframes = {}

	self.clientframes.main = CreateFrame("Frame", "DOKarma_ClientRollFrame", UIParent)
	self.clientframes.main:Hide()
	self.clientframes.main:SetWidth(325)
	self.clientframes.main:SetHeight(440)
	self.clientframes.main:EnableMouse(true)
	self.clientframes.main:SetMovable(true)
	self.clientframes.main:RegisterForDrag("LeftButton")
	self.clientframes.main:SetScript("OnDragStart", function() this:StartMoving() end)
	self.clientframes.main:SetScript("OnDragStop", function() this:StopMovingOrSizing() end)
	self.clientframes.main:SetBackdrop({
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", tile = true, tileSize = 16,
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16,
		insets = {left = 4, right = 4, top = 4, bottom = 4},
		})
	self.clientframes.main:SetBackdropBorderColor(.5, .5, .5)
	self.clientframes.main:SetBackdropColor(0,0,0)
	self.clientframes.main:ClearAllPoints()
	self.clientframes.main:SetPoint("CENTER", WorldFrame, "CENTER", 0, 0)

	self.clientframes.fade = self.clientframes.main:CreateTexture(nil, "BORDER")
	self.clientframes.fade:SetWidth(319)
	self.clientframes.fade:SetHeight(25)
	self.clientframes.fade:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.clientframes.fade:SetPoint("TOP", self.clientframes.main, "TOP", 0, -4)
	self.clientframes.fade:SetBlendMode("ADD")
	self.clientframes.fade:SetGradientAlpha("VERTICAL", .1, .1, .1, 0, .25, .25, .25, 1)
	self.clientframes.main.Fade = self.clientframes.fade

	self.clientframes.header = self.clientframes.main:CreateFontString(nil,"OVERLAY")
	self.clientframes.header:SetFont(f, 14)
	self.clientframes.header:SetWidth(350)
	self.clientframes.header:SetText("Client - Karma Roll Monitor")
	self.clientframes.header:SetTextColor(1, .8, 0)
	self.clientframes.header:ClearAllPoints()
	self.clientframes.header:SetPoint("TOP", self.clientframes.main, "TOP", 0, -10)

	self.clientframes.headername = CreateFrame("Button", nil, self.clientframes.main)
	self.clientframes.headername.owner = self
	self.clientframes.headername:SetWidth(150)
	self.clientframes.headername:SetHeight(16)
	self.clientframes.headername:SetPoint("TOPLEFT", self.clientframes.main, "TOPLEFT", 10, -35)
	self.clientframes.headername:SetScript("OnClick",
			function()
				this.owner:Sort(self.ClientKarmaRolls, 1)
				this.owner:UpdateClientScrollBar()
			end)

	self.clientframes.headernamehigh = self.clientframes.headername:CreateTexture(nil, "BORDER")
	self.clientframes.headernamehigh:SetWidth(150)
	self.clientframes.headernamehigh:SetHeight(16)
	self.clientframes.headernamehigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.clientframes.headernamehigh:SetAllPoints(self.clientframes.headername)
	self.clientframes.headernamehigh:SetBlendMode("ADD")
	self.clientframes.headernamehigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	self.clientframes.headername:SetHighlightTexture(self.clientframes.headernamehigh)

	self.clientframes.headernametext = self.clientframes.headername:CreateFontString(nil,"OVERLAY")
	self.clientframes.headernametext.owner = self
	self.clientframes.headernametext:SetFont(f, 14)
	self.clientframes.headernametext:SetWidth(150)
	self.clientframes.headernametext:SetText("Name")
	self.clientframes.headernametext:SetTextColor(1, .8, 0)
	self.clientframes.headernametext:ClearAllPoints()
	self.clientframes.headernametext:SetJustifyH("LEFT")
	self.clientframes.headernametext:SetAllPoints(self.clientframes.headername)

	self.clientframes.headerroll = CreateFrame("Button", nil, self.clientframes.main)
	self.clientframes.headerroll.owner = self
	self.clientframes.headerroll:SetWidth(50)
	self.clientframes.headerroll:SetHeight(16)
	self.clientframes.headerroll:SetPoint("LEFT", self.clientframes.headername, "RIGHT")
	self.clientframes.headerroll:SetScript("OnClick",
			function()
				this.owner:Sort(self.ClientKarmaRolls, 2)
				this.owner:UpdateClientScrollBar()
			end)

	self.clientframes.headerrollhigh = self.clientframes.headerroll:CreateTexture(nil, "BORDER")
	self.clientframes.headerrollhigh:SetWidth(50)
	self.clientframes.headerrollhigh:SetHeight(16)
	self.clientframes.headerrollhigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.clientframes.headerrollhigh:SetAllPoints(self.clientframes.headerroll)
	self.clientframes.headerrollhigh:SetBlendMode("ADD")
	self.clientframes.headerrollhigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	self.clientframes.headerroll:SetHighlightTexture(self.clientframes.headerrollhigh)


	self.clientframes.headerrolltext = self.clientframes.main:CreateFontString(nil,"OVERLAY")
	self.clientframes.headerrolltext:SetFont(f, 14)
	self.clientframes.headerrolltext:SetWidth(50)
	self.clientframes.headerrolltext:SetText("Roll")
	self.clientframes.headerrolltext:SetTextColor(1, .8, 0)
	self.clientframes.headerrolltext:ClearAllPoints()
	self.clientframes.headerrolltext:SetJustifyH("LEFT")
	self.clientframes.headerrolltext:SetAllPoints(self.clientframes.headerroll)

	self.clientframes.headertotal = CreateFrame("Button", nil, self.clientframes.main)
	self.clientframes.headertotal.owner = self
	self.clientframes.headertotal:SetWidth(80)
	self.clientframes.headertotal:SetHeight(16)
	self.clientframes.headertotal:SetPoint("LEFT", self.clientframes.headerroll, "RIGHT")
	self.clientframes.headertotal:SetScript("OnClick",
			function()
				this.owner:Sort(self.ClientKarmaRolls, 3)
				this.owner:UpdateClientScrollBar()
			end)

	self.clientframes.headertotalhigh = self.clientframes.headertotal:CreateTexture(nil, "BORDER")
	self.clientframes.headertotalhigh:SetWidth(80)
	self.clientframes.headertotalhigh:SetHeight(16)
	self.clientframes.headertotalhigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.clientframes.headertotalhigh:SetAllPoints(self.clientframes.headertotal)
	self.clientframes.headertotalhigh:SetBlendMode("ADD")
	self.clientframes.headertotalhigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	self.clientframes.headertotal:SetHighlightTexture(self.clientframes.headertotalhigh)


	self.clientframes.headertotaltext = self.clientframes.main:CreateFontString(nil,"OVERLAY")
	self.clientframes.headertotaltext.owner = self
	self.clientframes.headertotaltext:SetFont(f, 14)
	self.clientframes.headertotaltext:SetWidth(80)
	self.clientframes.headertotaltext:SetText("Total Roll")
	self.clientframes.headertotaltext:SetTextColor(1, .8, 0)
	self.clientframes.headertotaltext:ClearAllPoints()
	self.clientframes.headertotaltext:SetJustifyH("LEFT")
	self.clientframes.headertotaltext:SetAllPoints(self.clientframes.headertotal)

	--Pass Button
	self.clientframes.passbutton = CreateFrame("Button", nil, self.clientframes.main)
	self.clientframes.passbutton.owner = self
	self.clientframes.passbutton:SetWidth(80)
	self.clientframes.passbutton:SetHeight(32)
	self.clientframes.passbutton:SetPoint("BOTTOMLEFT", self.clientframes.main, "BOTTOM", -150, 10)

	t = self.clientframes.passbutton:CreateTexture()
	t:SetWidth(80)
	t:SetHeight(32)
	t:SetPoint("CENTER", self.clientframes.passbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	self.clientframes.passbutton:SetNormalTexture(t)

	t = self.clientframes.passbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.clientframes.passbutton)
	self.clientframes.passbutton:SetPushedTexture(t)
	
	t = self.clientframes.passbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.clientframes.passbutton)
	t:SetBlendMode("ADD")
	self.clientframes.passbutton:SetHighlightTexture(t)
	self.clientframes.passbuttontext = self.clientframes.passbutton:CreateFontString(nil,"OVERLAY")
	self.clientframes.passbuttontext:SetFontObject(GameFontHighlight)
	self.clientframes.passbuttontext:SetText("Pass")
	self.clientframes.passbuttontext:SetAllPoints(self.clientframes.passbutton)

	self.clientframes.passbutton:SetScript("OnClick",
			function()
				self:SendCommMessage("RAID", "PassOnRoll")
				this.owner.clientframes.rollbutton:Hide()
				this.owner.clientframes.passbutton:Hide()
			end)

	--Roll Button
	self.clientframes.rollbutton = CreateFrame("Button", nil, self.clientframes.main)
	self.clientframes.rollbutton.owner = self
	self.clientframes.rollbutton:SetWidth(80)
	self.clientframes.rollbutton:SetHeight(32)
	self.clientframes.rollbutton:SetPoint("BOTTOMLEFT", self.clientframes.main, "BOTTOM", -60, 10)

	t = self.clientframes.rollbutton:CreateTexture()
	t:SetWidth(80)
	t:SetHeight(32)
	t:SetPoint("CENTER", self.clientframes.rollbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	self.clientframes.rollbutton:SetNormalTexture(t)

	t = self.clientframes.rollbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.clientframes.rollbutton)
	self.clientframes.rollbutton:SetPushedTexture(t)
	
	t = self.clientframes.rollbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.clientframes.rollbutton)
	t:SetBlendMode("ADD")
	self.clientframes.rollbutton:SetHighlightTexture(t)
	self.clientframes.rollbuttontext = self.clientframes.rollbutton:CreateFontString(nil,"OVERLAY")
	self.clientframes.rollbuttontext:SetFontObject(GameFontHighlight)
	self.clientframes.rollbuttontext:SetText("Roll")
	self.clientframes.rollbuttontext:SetAllPoints(self.clientframes.rollbutton)

	self.clientframes.rollbutton:SetScript("OnClick",
			function()
				this.owner.clientframes.rollbutton:Hide()
				this.owner.clientframes.passbutton:Hide()
				RandomRoll(1, 100)
			end)

	--Close Button
	self.clientframes.closebutton = CreateFrame("Button", nil, self.clientframes.main)
	self.clientframes.closebutton.owner = self
	self.clientframes.closebutton:SetWidth(80)
	self.clientframes.closebutton:SetHeight(32)
	self.clientframes.closebutton:SetPoint("BOTTOMRIGHT", self.clientframes.main, "BOTTOM", 150, 10)
	
	t = self.clientframes.closebutton:CreateTexture()
	t:SetWidth(80)
	t:SetHeight(32)
	t:SetPoint("CENTER", self.clientframes.closebutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	self.clientframes.closebutton:SetNormalTexture(t)

	t = self.clientframes.closebutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.clientframes.closebutton)
	self.clientframes.closebutton:SetPushedTexture(t)
	
	t = self.clientframes.closebutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.clientframes.closebutton)
	t:SetBlendMode("ADD")
	self.clientframes.closebutton:SetHighlightTexture(t)
	self.clientframes.closebuttontext = self.clientframes.closebutton:CreateFontString(nil,"OVERLAY")
	self.clientframes.closebuttontext:SetFontObject(GameFontHighlight)
	self.clientframes.closebuttontext:SetText("Close")
	self.clientframes.closebuttontext:SetAllPoints(self.clientframes.closebutton)

	self.clientframes.closebutton:SetScript("OnClick",
			function()
				self.Settings.ClientRoll = false
				this.owner.clientframes.main:Hide()
			end)

	self.clientframes.entry = {}
	self.clientframes.entry[1] = self:ScrollEntryClientFrame(1)
	self.clientframes.entry[1]:SetPoint("TOPLEFT", self.clientframes.main, "TOPLEFT", 10, -55 )
	
	for i=2, 20 do
		j = i - 1
		self.clientframes.entry[i] = self:ScrollEntryClientFrame()
		self.clientframes.entry[i]:SetPoint("TOPLEFT", self.clientframes.entry[j], "BOTTOMLEFT")
	end

	self.clientframes.sframe = CreateFrame("ScrollFrame", "DOKarma_ClientRollScrollFrame", self.clientframes.main, "FauxScrollFrameTemplate")
	self.clientframes.sframe.owner = self
	self.clientframes.sframe:SetParent(self.clientframes.main)
	self.clientframes.sframe:SetWidth(285)
	self.clientframes.sframe:SetHeight(320)
	self.clientframes.sframe:SetPoint("TOPLEFT", self.clientframes.main, "TOPLEFT", 5, -55)

	self.clientframes.sframe:SetScript("OnVerticalScroll",
			function()
				FauxScrollFrame_OnVerticalScroll(16, function() this.owner:UpdateClientScrollBar() end)
			end )

end

function DOKarma:ScrollEntryClientFrame()
	local f = CreateFrame("Button", nil, self.clientframes.main )
	f:SetWidth(240)
	f:SetHeight(16)
	
	f.textname = f:CreateFontString(nil,"ARTWORK")
	f.textname:SetFontObject(GameFontHighlight)
	f.textname:SetWidth(150)
	f.textname:SetHeight(16)
	f.textname:SetJustifyH("LEFT")
	f.textname:SetNonSpaceWrap(false)
	f.textname:ClearAllPoints()
	f.textname:SetPoint( "LEFT", f, "LEFT")
	f.textname:SetTextColor(1,1,1)
	f.textname:SetText("Name")

	f.textroll = f:CreateFontString(nil,"ARTWORK")
	f.textroll:SetFontObject(GameFontHighlight)
	f.textroll:SetWidth(70)
	f.textroll:SetHeight(16)
	f.textroll:SetJustifyH("LEFT")
	f.textroll:SetNonSpaceWrap(false)
	f.textroll:ClearAllPoints()
	f.textroll:SetPoint("LEFT", f.textname, "RIGHT")
	f.textroll:SetTextColor(1,1,1)
	f.textroll:SetText("12%")

	f.texttotal = f:CreateFontString(nil,"ARTWORK")
	f.texttotal:SetFontObject(GameFontHighlight)
	f.texttotal:SetWidth(60)
	f.texttotal:SetHeight(16)
	f.texttotal:SetJustifyH("LEFT")
	f.texttotal:SetNonSpaceWrap(false)
	f.texttotal:ClearAllPoints()
	f.texttotal:SetPoint("LEFT", f.textroll, "RIGHT")
	f.texttotal:SetTextColor(1,1,1)
	f.texttotal:SetText("3")

	return f
end

function DOKarma:UpdateClientScrollBar()
	local i,j
	local entries = table.getn(self.ClientKarmaRolls)
	FauxScrollFrame_Update(self.clientframes.sframe, entries, 20, 16)

	for i = 1, 20 do
		j = i + FauxScrollFrame_GetOffset(self.clientframes.sframe)

		if j <= entries then
			if self.ClientKarmaRolls[j][6] == true then
				--self.clientframes.entry[i].textname:SetText(self.RollRoster[self.ClientKarmaRolls[j][1]].ColouredPassNameString)
				self.clientframes.entry[i].textname:SetText(self.ClientKarmaRolls[j][4])
			else
				--self.clientframes.entry[i].textname:SetText(self.RollRoster[self.ClientKarmaRolls[j][1]].ColouredNameString)
				self.clientframes.entry[i].textname:SetText(self.ClientKarmaRolls[j][4])
			end
			self.clientframes.entry[i].textroll:SetText(self.ClientKarmaRolls[j][2])
			self.clientframes.entry[i].texttotal:SetText(self.ClientKarmaRolls[j][3])
			self.clientframes.entry[i]:Show()
		else
			self.clientframes.entry[i]:Hide()
		end
	end

end

--Addon Checking Frames Start Here

function DOKarma:SetupAddonFrames()
	local f, t, sframe, i, j

	f, _, _ = GameFontNormal:GetFont()

	self.addonframes = {}

	self.addonframes.main = CreateFrame("Frame", "DOKarma_AddonVersions", UIParent)
	self.addonframes.main:Hide()
	self.addonframes.main:SetWidth(600)
	self.addonframes.main:SetHeight(440)
	self.addonframes.main:EnableMouse(true)
	self.addonframes.main:SetMovable(true)
	self.addonframes.main:RegisterForDrag("LeftButton")
	self.addonframes.main:SetScript("OnDragStart", function() this:StartMoving() end)
	self.addonframes.main:SetScript("OnDragStop", function() this:StopMovingOrSizing() end)
	self.addonframes.main:SetBackdrop({
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", tile = true, tileSize = 16,
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16,
		insets = {left = 4, right = 4, top = 4, bottom = 4},
		})
	self.addonframes.main:SetBackdropBorderColor(.5, .5, .5)
	self.addonframes.main:SetBackdropColor(0,0,0)
	self.addonframes.main:ClearAllPoints()
	self.addonframes.main:SetPoint("CENTER", WorldFrame, "CENTER", 0, 0)

	self.addonframes.fade = self.addonframes.main:CreateTexture(nil, "BORDER")
	self.addonframes.fade:SetWidth(594)
	self.addonframes.fade:SetHeight(25)
	self.addonframes.fade:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.addonframes.fade:SetPoint("TOP", self.addonframes.main, "TOP", 0, -4)
	self.addonframes.fade:SetBlendMode("ADD")
	self.addonframes.fade:SetGradientAlpha("VERTICAL", .1, .1, .1, 0, .25, .25, .25, 1)
	self.addonframes.main.Fade = self.addonframes.fade

	self.addonframes.header = self.addonframes.main:CreateFontString(nil,"OVERLAY")
	self.addonframes.header:SetFont(f, 14)
	self.addonframes.header:SetWidth(594)
	self.addonframes.header:SetText("Guild Addon Versions")
	self.addonframes.header:SetTextColor(1, .8, 0)
	self.addonframes.header:ClearAllPoints()
	self.addonframes.header:SetPoint("TOP", self.addonframes.main, "TOP", 0, -10)

	--Name
	self.addonframes.headername = CreateFrame("Button", nil, self.addonframes.main)
	self.addonframes.headername.owner = self
	self.addonframes.headername:SetWidth(100)
	self.addonframes.headername:SetHeight(16)
	self.addonframes.headername:SetPoint("TOPLEFT", self.addonframes.main, "TOPLEFT", 10, -35)
	self.addonframes.headername:SetScript("OnClick",
			function()
				this.owner:Sort(self.AddonVersionList, 1)
				this.owner:UpdateAddonScrollBar()
			end)

	self.addonframes.headernamehigh = self.addonframes.headername:CreateTexture(nil, "BORDER")
	self.addonframes.headernamehigh:SetWidth(100)
	self.addonframes.headernamehigh:SetHeight(16)
	self.addonframes.headernamehigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.addonframes.headernamehigh:SetAllPoints(self.addonframes.headername)
	self.addonframes.headernamehigh:SetBlendMode("ADD")
	self.addonframes.headernamehigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	self.addonframes.headername:SetHighlightTexture(self.addonframes.headernamehigh)

	self.addonframes.headernametext = self.addonframes.headername:CreateFontString(nil,"OVERLAY")
	self.addonframes.headernametext.owner = self
	self.addonframes.headernametext:SetFont(f, 14)
	self.addonframes.headernametext:SetWidth(100)
	self.addonframes.headernametext:SetText("Name")
	self.addonframes.headernametext:SetTextColor(1, .8, 0)
	self.addonframes.headernametext:ClearAllPoints()
	self.addonframes.headernametext:SetJustifyH("LEFT")
	self.addonframes.headernametext:SetAllPoints(self.addonframes.headername)

	--Addon 1
	self.addonframes.headeraddon1 = CreateFrame("Button", nil, self.addonframes.main)
	self.addonframes.headeraddon1.owner = self
	self.addonframes.headeraddon1:SetWidth(95)
	self.addonframes.headeraddon1:SetHeight(16)
	self.addonframes.headeraddon1:SetPoint("LEFT", self.addonframes.headername, "RIGHT")
	self.addonframes.headeraddon1:SetScript("OnClick",
			function()
				this.owner:Sort(self.AddonVersionList, 2)
				this.owner:UpdateAddonScrollBar()
			end)

	self.addonframes.headeraddon1high = self.addonframes.headeraddon1:CreateTexture(nil, "BORDER")
	self.addonframes.headeraddon1high:SetWidth(95)
	self.addonframes.headeraddon1high:SetHeight(16)
	self.addonframes.headeraddon1high:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.addonframes.headeraddon1high:SetAllPoints(self.addonframes.headeraddon1)
	self.addonframes.headeraddon1high:SetBlendMode("ADD")
	self.addonframes.headeraddon1high:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	self.addonframes.headeraddon1:SetHighlightTexture(self.addonframes.headeraddon1high)


	self.addonframes.headeraddon1text = self.addonframes.main:CreateFontString(nil,"OVERLAY")
	self.addonframes.headeraddon1text:SetFont(f, 10)
	self.addonframes.headeraddon1text:SetWidth(95)
	if self.db.profile.AddonList[1] then
		self.addonframes.headeraddon1text:SetText(self.db.profile.AddonList[1].AddonName)
	else
		self.addonframes.headeraddon1text:SetText("")
	end
	self.addonframes.headeraddon1text:SetTextColor(1, .8, 0)
	self.addonframes.headeraddon1text:ClearAllPoints()
	self.addonframes.headeraddon1text:SetJustifyH("LEFT")
	self.addonframes.headeraddon1text:SetAllPoints(self.addonframes.headeraddon1)

	--Addon 2
	self.addonframes.headeraddon2 = CreateFrame("Button", nil, self.addonframes.main)
	self.addonframes.headeraddon2.owner = self
	self.addonframes.headeraddon2:SetWidth(95)
	self.addonframes.headeraddon2:SetHeight(16)
	self.addonframes.headeraddon2:SetPoint("LEFT", self.addonframes.headeraddon1, "RIGHT")
	self.addonframes.headeraddon2:SetScript("OnClick",
			function()
				this.owner:Sort(self.AddonVersionList, 3)
				this.owner:UpdateAddonScrollBar()
			end)

	self.addonframes.headeraddon2high = self.addonframes.headeraddon2:CreateTexture(nil, "BORDER")
	self.addonframes.headeraddon2high:SetWidth(95)
	self.addonframes.headeraddon2high:SetHeight(16)
	self.addonframes.headeraddon2high:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.addonframes.headeraddon2high:SetAllPoints(self.addonframes.headeraddon2)
	self.addonframes.headeraddon2high:SetBlendMode("ADD")
	self.addonframes.headeraddon2high:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	self.addonframes.headeraddon2:SetHighlightTexture(self.addonframes.headeraddon2high)

	self.addonframes.headeraddon2text = self.addonframes.main:CreateFontString(nil,"OVERLAY")
	self.addonframes.headeraddon2text.owner = self
	self.addonframes.headeraddon2text:SetFont(f, 10)
	self.addonframes.headeraddon2text:SetWidth(95)
	if self.db.profile.AddonList[2] then
		self.addonframes.headeraddon2text:SetText(self.db.profile.AddonList[2].AddonName)
	else
		self.addonframes.headeraddon2text:SetText("")
	end
	self.addonframes.headeraddon2text:SetTextColor(1, .8, 0)
	self.addonframes.headeraddon2text:ClearAllPoints()
	self.addonframes.headeraddon2text:SetJustifyH("LEFT")
	self.addonframes.headeraddon2text:SetAllPoints(self.addonframes.headeraddon2)

	--Addon 3
	self.addonframes.headeraddon3 = CreateFrame("Button", nil, self.addonframes.main)
	self.addonframes.headeraddon3.owner = self
	self.addonframes.headeraddon3:SetWidth(95)
	self.addonframes.headeraddon3:SetHeight(16)
	self.addonframes.headeraddon3:SetPoint("LEFT", self.addonframes.headeraddon2, "RIGHT")
	self.addonframes.headeraddon3:SetScript("OnClick",
			function()
				this.owner:Sort(self.AddonVersionList, 4)
				this.owner:UpdateAddonScrollBar()
			end)

	self.addonframes.headeraddon3high = self.addonframes.headeraddon3:CreateTexture(nil, "BORDER")
	self.addonframes.headeraddon3high:SetWidth(95)
	self.addonframes.headeraddon3high:SetHeight(16)
	self.addonframes.headeraddon3high:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.addonframes.headeraddon3high:SetAllPoints(self.addonframes.headeraddon3)
	self.addonframes.headeraddon3high:SetBlendMode("ADD")
	self.addonframes.headeraddon3high:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	self.addonframes.headeraddon3:SetHighlightTexture(self.addonframes.headeraddon3high)

	self.addonframes.headeraddon3text = self.addonframes.main:CreateFontString(nil,"OVERLAY")
	self.addonframes.headeraddon3text.owner = self
	self.addonframes.headeraddon3text:SetFont(f, 10)
	self.addonframes.headeraddon3text:SetWidth(95)
	if self.db.profile.AddonList[3] then
		self.addonframes.headeraddon3text:SetText(self.db.profile.AddonList[3].AddonName)
	else
		self.addonframes.headeraddon3text:SetText("")
	end
	self.addonframes.headeraddon3text:SetTextColor(1, .8, 0)
	self.addonframes.headeraddon3text:ClearAllPoints()
	self.addonframes.headeraddon3text:SetJustifyH("LEFT")
	self.addonframes.headeraddon3text:SetAllPoints(self.addonframes.headeraddon3)

	--Addon 4
	self.addonframes.headeraddon4 = CreateFrame("Button", nil, self.addonframes.main)
	self.addonframes.headeraddon4.owner = self
	self.addonframes.headeraddon4:SetWidth(95)
	self.addonframes.headeraddon4:SetHeight(16)
	self.addonframes.headeraddon4:SetPoint("LEFT", self.addonframes.headeraddon3, "RIGHT")
	self.addonframes.headeraddon4:SetScript("OnClick",
			function()
				this.owner:Sort(self.AddonVersionList, 5)
				this.owner:UpdateAddonScrollBar()
			end)

	self.addonframes.headeraddon4high = self.addonframes.headeraddon4:CreateTexture(nil, "BORDER")
	self.addonframes.headeraddon4high:SetWidth(95)
	self.addonframes.headeraddon4high:SetHeight(16)
	self.addonframes.headeraddon4high:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.addonframes.headeraddon4high:SetAllPoints(self.addonframes.headeraddon4)
	self.addonframes.headeraddon4high:SetBlendMode("ADD")
	self.addonframes.headeraddon4high:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	self.addonframes.headeraddon4:SetHighlightTexture(self.addonframes.headeraddon4high)

	self.addonframes.headeraddon4text = self.addonframes.main:CreateFontString(nil,"OVERLAY")
	self.addonframes.headeraddon4text.owner = self
	self.addonframes.headeraddon4text:SetFont(f, 10)
	self.addonframes.headeraddon4text:SetWidth(95)
	if self.db.profile.AddonList[4] then
		self.addonframes.headeraddon4text:SetText(self.db.profile.AddonList[4].AddonName)
	else
		self.addonframes.headeraddon4text:SetText("")
	end
	self.addonframes.headeraddon4text:SetTextColor(1, .8, 0)
	self.addonframes.headeraddon4text:ClearAllPoints()
	self.addonframes.headeraddon4text:SetJustifyH("LEFT")
	self.addonframes.headeraddon4text:SetAllPoints(self.addonframes.headeraddon4)

	--Addon 5
	self.addonframes.headeraddon5 = CreateFrame("Button", nil, self.addonframes.main)
	self.addonframes.headeraddon5.owner = self
	self.addonframes.headeraddon5:SetWidth(95)
	self.addonframes.headeraddon5:SetHeight(16)
	self.addonframes.headeraddon5:SetPoint("LEFT", self.addonframes.headeraddon4, "RIGHT")
	self.addonframes.headeraddon5:SetScript("OnClick",
			function()
				this.owner:Sort(self.AddonVersionList, 6)
				this.owner:UpdateAddonScrollBar()
			end)

	self.addonframes.headeraddon5high = self.addonframes.headeraddon5:CreateTexture(nil, "BORDER")
	self.addonframes.headeraddon5high:SetWidth(95)
	self.addonframes.headeraddon5high:SetHeight(16)
	self.addonframes.headeraddon5high:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	self.addonframes.headeraddon5high:SetAllPoints(self.addonframes.headeraddon5)
	self.addonframes.headeraddon5high:SetBlendMode("ADD")
	self.addonframes.headeraddon5high:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	self.addonframes.headeraddon5:SetHighlightTexture(self.addonframes.headeraddon5high)

	self.addonframes.headeraddon5text = self.addonframes.main:CreateFontString(nil,"OVERLAY")
	self.addonframes.headeraddon5text.owner = self
	self.addonframes.headeraddon5text:SetFont(f, 10)
	self.addonframes.headeraddon5text:SetWidth(95)
	if self.db.profile.AddonList[5] then
		self.addonframes.headeraddon5text:SetText(self.db.profile.AddonList[5].AddonName)
	else
		self.addonframes.headeraddon5text:SetText("")
	end
	self.addonframes.headeraddon5text:SetTextColor(1, .8, 0)
	self.addonframes.headeraddon5text:ClearAllPoints()
	self.addonframes.headeraddon5text:SetJustifyH("LEFT")
	self.addonframes.headeraddon5text:SetAllPoints(self.addonframes.headeraddon5)

	--Refresh Button
	self.addonframes.passbutton = CreateFrame("Button", nil, self.addonframes.main)
	self.addonframes.passbutton.owner = self
	self.addonframes.passbutton:SetWidth(80)
	self.addonframes.passbutton:SetHeight(32)
	self.addonframes.passbutton:SetPoint("BOTTOMLEFT", self.addonframes.main, "BOTTOM", -150, 10)

	t = self.addonframes.passbutton:CreateTexture()
	t:SetWidth(80)
	t:SetHeight(32)
	t:SetPoint("CENTER", self.addonframes.passbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	self.addonframes.passbutton:SetNormalTexture(t)

	t = self.addonframes.passbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.addonframes.passbutton)
	self.addonframes.passbutton:SetPushedTexture(t)
	
	t = self.addonframes.passbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.addonframes.passbutton)
	t:SetBlendMode("ADD")
	self.addonframes.passbutton:SetHighlightTexture(t)
	self.addonframes.passbuttontext = self.addonframes.passbutton:CreateFontString(nil,"OVERLAY")
	self.addonframes.passbuttontext:SetFontObject(GameFontHighlight)
	self.addonframes.passbuttontext:SetText("Refresh")
	self.addonframes.passbuttontext:SetAllPoints(self.addonframes.passbutton)

	self.addonframes.passbutton:SetScript("OnClick",
			function()
				DOKarma:DoAddonCheck()
			end)

	--Close Button
	self.addonframes.closebutton = CreateFrame("Button", nil, self.addonframes.main)
	self.addonframes.closebutton.owner = self
	self.addonframes.closebutton:SetWidth(80)
	self.addonframes.closebutton:SetHeight(32)
	self.addonframes.closebutton:SetPoint("BOTTOMRIGHT", self.addonframes.main, "BOTTOM", 150, 10)
	
	t = self.addonframes.closebutton:CreateTexture()
	t:SetWidth(80)
	t:SetHeight(32)
	t:SetPoint("CENTER", self.addonframes.closebutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	self.addonframes.closebutton:SetNormalTexture(t)

	t = self.addonframes.closebutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.addonframes.closebutton)
	self.addonframes.closebutton:SetPushedTexture(t)
	
	t = self.addonframes.closebutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(self.addonframes.closebutton)
	t:SetBlendMode("ADD")
	self.addonframes.closebutton:SetHighlightTexture(t)
	self.addonframes.closebuttontext = self.addonframes.closebutton:CreateFontString(nil,"OVERLAY")
	self.addonframes.closebuttontext:SetFontObject(GameFontHighlight)
	self.addonframes.closebuttontext:SetText("Close")
	self.addonframes.closebuttontext:SetAllPoints(self.addonframes.closebutton)

	self.addonframes.closebutton:SetScript("OnClick",
			function()
				this.owner.addonframes.main:Hide()
			end)

	self.addonframes.entry = {}
	self.addonframes.entry[1] = self:ScrollEntryAddonFrame(1)
	self.addonframes.entry[1]:SetPoint("TOPLEFT", self.addonframes.main, "TOPLEFT", 10, -55 )
	
	for i=2, 20 do
		j = i - 1
		self.addonframes.entry[i] = self:ScrollEntryAddonFrame()
		self.addonframes.entry[i]:SetPoint("TOPLEFT", self.addonframes.entry[j], "BOTTOMLEFT")
	end

	self.addonframes.sframe = CreateFrame("ScrollFrame", "DOKarma_AddonScrollFrame", self.addonframes.main, "FauxScrollFrameTemplate")
	self.addonframes.sframe.owner = self
	self.addonframes.sframe:SetParent(self.addonframes.main)
	self.addonframes.sframe:SetWidth(560)
	self.addonframes.sframe:SetHeight(320)
	self.addonframes.sframe:SetPoint("TOPLEFT", self.addonframes.main, "TOPLEFT", 5, -55)

	self.addonframes.sframe:SetScript("OnVerticalScroll",
			function()
				FauxScrollFrame_OnVerticalScroll(16, function() this.owner:UpdateAddonScrollBar() end)
			end )

end

function DOKarma:ScrollEntryAddonFrame()
	local f = CreateFrame("Button", nil, self.addonframes.main )
	local font
	font, _, _ = GameFontNormal:GetFont()
	f:SetWidth(515)
	f:SetHeight(16)
	
	f.textname = f:CreateFontString(nil,"ARTWORK")
	f.textname:SetFontObject(GameFontHighlight)
	f.textname:SetWidth(100)
	f.textname:SetHeight(16)
	f.textname:SetJustifyH("LEFT")
	f.textname:SetNonSpaceWrap(false)
	f.textname:ClearAllPoints()
	f.textname:SetPoint( "LEFT", f, "LEFT")
	f.textname:SetTextColor(1,1,1)
	f.textname:SetText("Name")

	f.texta1 = f:CreateFontString(nil,"ARTWORK")
	f.texta1:SetFontObject(GameFontHighlight)
	f.texta1:SetWidth(95)
	f.texta1:SetHeight(16)
	f.texta1:SetJustifyH("LEFT")
	f.texta1:SetNonSpaceWrap(false)
	f.texta1:ClearAllPoints()
	f.texta1:SetPoint("LEFT", f.textname, "RIGHT")
	f.texta1:SetTextColor(1,1,1)
	f.texta1:SetText("12%")

	f.texta2 = f:CreateFontString(nil,"ARTWORK")
	f.texta2:SetFontObject(GameFontHighlight)
	f.texta2:SetWidth(95)
	f.texta2:SetHeight(16)
	f.texta2:SetJustifyH("LEFT")
	f.texta2:SetNonSpaceWrap(false)
	f.texta2:ClearAllPoints()
	f.texta2:SetPoint("LEFT", f.texta1, "RIGHT")
	f.texta2:SetTextColor(1,1,1)
	f.texta2:SetText("12%")

	f.texta3 = f:CreateFontString(nil,"ARTWORK")
	f.texta3:SetFontObject(GameFontHighlight)
	f.texta3:SetWidth(95)
	f.texta3:SetHeight(16)
	f.texta3:SetJustifyH("LEFT")
	f.texta3:SetNonSpaceWrap(false)
	f.texta3:ClearAllPoints()
	f.texta3:SetPoint("LEFT", f.texta2, "RIGHT")
	f.texta3:SetTextColor(1,1,1)
	f.texta3:SetText("12%")

	f.texta4 = f:CreateFontString(nil,"ARTWORK")
	f.texta4:SetFontObject(GameFontHighlight)
	f.texta4:SetWidth(95)
	f.texta4:SetHeight(16)
	f.texta4:SetJustifyH("LEFT")
	f.texta4:SetNonSpaceWrap(false)
	f.texta4:ClearAllPoints()
	f.texta4:SetPoint("LEFT", f.texta3, "RIGHT")
	f.texta4:SetTextColor(1,1,1)
	f.texta4:SetText("12%")

	f.texta5 = f:CreateFontString(nil,"ARTWORK")
	f.texta5:SetFontObject(GameFontHighlight)
	f.texta5:SetWidth(95)
	f.texta5:SetHeight(16)
	f.texta5:SetJustifyH("LEFT")
	f.texta5:SetNonSpaceWrap(false)
	f.texta5:ClearAllPoints()
	f.texta5:SetPoint("LEFT", f.texta4, "RIGHT")
	f.texta5:SetTextColor(1,1,1)
	f.texta5:SetText("12%")

	return f
end

function DOKarma:UpdateAddonScrollBar()
	local i,j
	local entries = table.getn(self.AddonVersionList)
	FauxScrollFrame_Update(self.addonframes.sframe, entries, 20, 16)

	for i = 1, 20 do
		j = i + FauxScrollFrame_GetOffset(self.addonframes.sframe)

		if j <= entries then
			self.addonframes.entry[i].textname:SetText(self.AddonVersionList[j][1])
			self.addonframes.entry[i].texta1:SetText(self.AddonVersionList[j][2])
			self.addonframes.entry[i].texta2:SetText(self.AddonVersionList[j][3])
			self.addonframes.entry[i].texta3:SetText(self.AddonVersionList[j][4])
			self.addonframes.entry[i].texta4:SetText(self.AddonVersionList[j][5])
			self.addonframes.entry[i].texta5:SetText(self.AddonVersionList[j][6])
			self.addonframes.entry[i]:Show()
		else
			self.addonframes.entry[i]:Hide()
		end
	end

end
