
DOKarma = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0", "AceHook-2.1")

tablet = AceLibrary("Tablet-2.0")
dewdrop = AceLibrary("Dewdrop-2.0")

function getnewtable() return {} end
function reclaimtable(t) t = nil end

DOKarma:RegisterDB("DOKarmaDB")
DOKarma:RegisterDefaults('profile', {
	MMPosition = 250
	,AddonList = {
					"DOKarma"
					,"oRA2"
					,"KLHThreatMeter"
					,"BigWigs"
					,"CT_RaidAssist"
			}
	,SortByName = true
	,DisplayLocation = false
})

function DOKarma:OnInitialize()

    self.hasIcon = true
    self:SetIcon(true)
	self.defaultMinimapPosition = self.db.profile.MMPosition
	self.cannotDetachTooltip = true
	self.clickableTooltip = true

	--Setup Defaults and Declare Variables
	self.GuildRoster = getnewtable()
	self.Settings = getnewtable()
	self.RaidRoster = getnewtable()

	self.Settings.CanChangeNote = false
	self.Settings.IsInGuild = false
	self.Settings.LocalPlayer = nil
	self.Settings.LocalPlayerGuildRank = nil
	self.Settings.IsActiveRoll = false
	self.Settings.SetupCount = 0
	self.Settings.InitialisationPoints = 0

	self.Settings.MaxPoints = 0
	self.Settings.MinRankToUseKarma = 0
	self.Settings.AttendancePoints = 0
	self.Settings.DefaultsFound = false
	self.Settings.RaidTimerActivated = false
	self.Settings.RaidTimerInterval = 0
	self.Settings.RaidTimerPoints = 0
	self.Settings.RaidCustomPoints = 0

	self.Settings.RaidTimerStarted = false
	self.Settings.RaidTimerStarter = nil
	self.Settings.IsOfficer = false
	self.Settings.TimerName = "DOKarma TimerTick"
	self.Settings.DoRoll = false
	self.Settings.GuildName = nil
	self.Settings.OfficerRank = 3
	self.Settings.AllowedToAwardPoints = false
	self.Settings.IsRolling = false
	self.Settings.RollRecord = {}
	self.Settings.NumGuildRanks = 0
	self.Settings.CurrentAllowedVersion = nil
	self.Settings.VersionUpToDate = false
	self.Settings.IsInitialised = false
	self.Settings.ClientRoll = false
	self.Settings.FeaturesInactive = false
	self.Settings.SortByName = true
	
	--Guild Setup Variables
	self.Settings.InitialisationPoints = 0
	self.Settings.DefaultRaidTimerLength = 0
	self.Settings.DefaultTimerPointAward = 0
	self.Settings.MaximumKarma = 0
	self.Settings.MinimumRank = 0
	self.Settings.AttendancePoints = 0


	local options = {
	type = 'group',
	args = {
		enable = {
			type = 'execute',
			name = "Enable",
			desc = "Will Enable mod if you have disabled it.",
			func = function()
				self:Show()
			end
			}
		}
	}

    self:RegisterChatCommand({"/DOKarma"}, options)
	self:Hook("ToggleDropDownMenu", "DOToggleDropDownMenu", true)

end

function DOKarma:OnEnable()
	GuildRoster()
	self.Settings.IsInGuild = IsInGuild() == 1
	self:Update()
	self:ScheduleEvent(self.SetupMod, 5, self)
end

function DOKarma:GetColoredTextByClass(Text, Class)
	local class = string.upper(Class) or "WARRIOR"
	local color = RAID_CLASS_COLORS[class]
	return string.format("|cFF%02x%02x%02x%s|r", color.r*255, color.g*255, color.b*255, Text)
end

function DOKarma:SetupMod()

	self.Settings.IsInGuild = IsInGuild() == 1

	if self.Settings.IsInGuild and DOKarma:GetConfigData() == true then

		self:ScheduleRepeatingEvent("ScheduledGuildRoster", GuildRoster, 20)

		self:RegisterEvent("CHAT_MSG_SYSTEM","LookingForRolls")
		self:RegisterEvent("GUILD_ROSTER_UPDATE", "UpdateInternalGuildRoster")
		self:RegisterEvent("RAID_ROSTER_UPDATE", "MaintainRaidRoster")
		self:RegisterEvent("CHAT_MSG_ADDON", "OnCommReceive")

		self.ClientKarmaRolls = getnewtable()
		self.KarmaRolls = getnewtable()
		self.AddonVersionList = getnewtable()

		self.sorting = getnewtable()
		self.sorting[1] = "Name"
		self.sorting[2] = "Roll"
		self.sorting[3] = "Total"

		self:SetupFrames()
		self:SetupClientFrames()
		self:SetupAddonFrames()

		if UnitInRaid("player") then
			DOKarma:MaintainRaidRoster()
		end


		if self.Settings.RaidTimerActivated then
			self.Settings.RaidTimerActivated = false
			self:Print("Raid Timer disabled.  Turn on again if needed.")
		end
		
		self.Settings.DefaultRaidTimerLength = self.Settings.RaidTimerInterval
		self.Settings.DefaultTimerPointAward = self.Settings.RaidTimerPoints
		self.Settings.MaximumKarma = self.Settings.MaxPoints
		self.Settings.MinimumRank = self.Settings.MinRankToUseKarma
		self.Settings.AttendancePoints = self.Settings.AttendancePoints

		self.Settings.IsInitialised = true
		DOKarma:UpdateInternalGuildRoster()
	else
		self.Settings.IsInitialised = true
		self.Settings.FeaturesInactive = true
		self:Update()
	end
end

function DOKarma:GetConfigData()
		local DOData, GuildInfoText
		GuildInfoText = GetGuildInfoText()

		local guildName, guildRankName, guildRankID = GetGuildInfo("player")
		self.Settings.LocalPlayerGuildRank = guildRankID
		self.Settings.CanChangeNote = CanEditOfficerNote() == 1
		self.Settings.LocalPlayer = UnitName("player")
		
		if GuildInfoText and string.len(GuildInfoText) ~= 0 then
			_,_,DOData = string.find(GuildInfoText, "(<DK/.+/>)")
		else
			return false
		end

		if DOData then
			local MinRankToUseKarma, MaxPoints, TimerLength, TimerPoints, Version, AttendancePoints
			_,_,TimerLength = string.find(DOData,"/T:(%d+)/")
			_,_,TimerPoints = string.find(DOData,"/P:(%d+)/")
			_,_,Version = string.find(DOData,"/V:(%d+%.%d+)/")
			_,_,MaxPoints = string.find(DOData,"/M:(%d+)/")
			_,_,MinRankToUseKarma = string.find(DOData,"/MR:(%d+)/")
			_,_,AttendancePoints = string.find(DOData,"/AP:(%d+)/")

			self.Settings.RaidTimerInterval = tonumber(TimerLength)
			self.Settings.RaidTimerPoints = tonumber(TimerPoints)
			self.Settings.CurrentAllowedVersion = Version
			self.Settings.MaxPoints = tonumber(MaxPoints)
			self.Settings.MinRankToUseKarma = tonumber(MinRankToUseKarma)
			self.Settings.AttendancePoints = tonumber(AttendancePoints)
			self.Settings.DefaultsFound = true

			self.Settings.VersionUpToDate = self.version >= self.Settings.CurrentAllowedVersion
			return true
		else
			self.Settings.DefaultsFound = false
			return false
		end
end

function DOKarma:NotRolled()

	local returnstring
	for name in pairs(self.RaidRoster) do 
		if DOKarma:CheckRollList(name) ~= true then
			if returnstring then
				returnstring = returnstring..", "..self.RaidRoster[name].ColouredNameString
			else
				returnstring = self.RaidRoster[name].ColouredNameString
			end
		end
	end
	self:Print(returnstring)

end

function DOKarma:SendCommMessage(distribution, ...)

	local prefix = "DOKarma"..self.version
	local addonmessage, preparedmessage
	local tmp = {}
	local n = 1

	if select('#', ...) == 1 then
		addonmessage = ...
	else
		for i = 1, select('#', ...) do
			tmp[n] = select(i, ...)
			n = n + 1
		end
		addonmessage = tmp
	end

	if type(addonmessage) ~= "table" then
		preparedmessage = "O" .. self:DOencode(addonmessage)
	else
		preparedmessage = "T" .. self:DOencode(self:pickle(addonmessage))
	end
	
	SendAddonMessage(prefix, preparedmessage, distribution)

end

function DOKarma:OnCommReceive(prefix, encodedmessage, distribution, sender)
	
	if prefix ~= "DOKarma"..self.version then
		return
	end

	if sender == self.Settings.LocalPlayer then
		return
	end
	
	local decoded, unpickled, extras, message
	
	if string.sub(encodedmessage, 1, 1) == "T" then
		decoded = self:DOdecode(string.sub(encodedmessage, 2))
		unpickled = self:unpickle(decoded)
		message = unpickled[1]
		extras = unpickled[2]
	else
	 	message = self:DOdecode(string.sub(encodedmessage, 2))
	end
	
	if message == "RequestModStatus" then
		self:SendCommMessage("GUILD", "ModStatusReponse", DOKarma:NewModStatResponse(extras))
	elseif message == "ModStatusReponse" then
		self:AddonVersionUpdate(sender, extras)
	elseif message == "ShowClientRollFrame" then
		self:ShowClientRollFrame()
	elseif message == "HideClientRollFrame" then
		self:HideClientRollFrame()
	elseif message == "PassOnRoll" then
		self:PassOnRoll(sender)
	elseif message == "RollForClientFrame" then
		self:RollForClientFrame(extras)
	elseif message == "TimerStarted" then
		if extras == "true" then
			self.Settings.RaidTimerStarted = true
		else
			self.Settings.RaidTimerStarted = false
		end
		self.Settings.RaidTimerStarter = sender
	end

end

function DOKarma:RollForClientFrame(Details)
	if Details[6] == "true" then
		table.insert(self.ClientKarmaRolls, {Details[1], tonumber(Details[2]), tonumber(Details[3]), self.RaidRoster[Details[1]].ColouredPassNameString, tonumber(Details[4]), true})
	else
		table.insert(self.ClientKarmaRolls, {Details[1], tonumber(Details[2]), tonumber(Details[3]), self.RaidRoster[Details[1]].ColouredNameString, tonumber(Details[4]), false})
	end
	self:Sort(self.ClientKarmaRolls, 3)
	self:UpdateClientScrollBar()
end

function DOKarma:PassOnRoll(PassingMember)
	if self.Settings.IsActiveRoll then
		table.insert(self.KarmaRolls, {PassingMember, tonumber(0), tonumber(0), self.RaidRoster[PassingMember].ColouredPassNameString, tonumber(100), true})
		self:SendCommMessage("RAID", "RollForClientFrame", { PassingMember, 0, 0, 0, 0, "true" } )
		self:Sort(self.KarmaRolls, 3)
		self:UpdateScrollBar()
	end
end

function DOKarma:HideClientRollFrame()
	self.Settings.ClientRoll = false
	self.clientframes.main:Hide()
end

function DOKarma:ShowClientRollFrame()
	reclaimtable(self.ClientKarmaRolls)
	self.ClientKarmaRolls = nil
	self.ClientKarmaRolls = getnewtable()
	
	self.clientframes.rollbutton:Show()
	self.clientframes.passbutton:Show()
	
	self.Settings.ClientRoll = true
	self.clientframes.main:Show()
	self:UpdateClientScrollBar()
end

function DOKarma:DoAddonCheck()

	reclaimtable(self.AddonVersionList)
	self.AddonVersionList = nil
	self.AddonVersionList = getnewtable()

	DOKarma:UpdateAddonScrollBar()
	self.addonframes.main:Show()

	self:SendCommMessage("GUILD", "RequestModStatus", self.db.profile.AddonList)
	self:AddonVersionUpdate(self.Settings.LocalPlayer, self:NewModStatResponse(self:PickleClone(self.db.profile.AddonList)))
end

function DOKarma:AddonVersionUpdate(PlayerName, TableofAddons)
	table.insert(self.AddonVersionList,{PlayerName, TableofAddons[1], TableofAddons[2], TableofAddons[3],  TableofAddons[4], TableofAddons[5]} )
	DOKarma:UpdateAddonScrollBar()
end

function DOKarma:NewModStatResponse(AddonTable)
	local VersionTable = {}
	for key, value in pairs(AddonTable) do
		if value then
			active, version = DOKarma:ModStatusCheck(value)
			if active then
				if version then
					VersionTable[key] = version
				else
					VersionTable[key]  = "VNF"
				end
			else
				VersionTable[key]  = "NA"
			end
		end
	end
	return VersionTable
end

function DOKarma:split(str, pat)
   local t = {}
   local fpat = "(.-)" .. pat
   local last_end = 1
   local s, e, cap = string.find(str, fpat, 1)
   while s do
      if s ~= 1 or cap ~= "" then
	 table.insert(t,cap)
      end
      last_end = e+1
      s, e, cap = string.find(str, fpat, last_end)
   end
   if last_end <= string.len(str) then
      cap = string.sub(str, last_end)
      table.insert(t, cap)
   end
   return t
end

function DOKarma:ModStatusCheck(ModName)
	if IsAddOnLoaded(ModName) then
		local Version, returnversion
		Version = GetAddOnMetadata(ModName, "Version")

		if Version then
			returnversion = string.gsub(Version,"%$Revision: ","")
			returnversion = string.gsub(returnversion," %$","")
		end

		return true, returnversion
	else
		return nill
	end
end

function DOKarma:MaintainRaidRoster()

 	if UnitInRaid("player") then
		local temp = getnewtable()

		if self.Settings.RaidTimerActivated then
			self:SendCommMessage("RAID", "TimerStarted", true)
		end

		for name in pairs(self.RaidRoster) do 
			temp[name] = true
		end

 		for UnitID = 1, 40 do
			local name = self:CreateOrUpdateUnit(UnitID)
			if name then temp[name] = nil end
		end

		for name in pairs(temp) do
			self:RemoveUnit(name)
		end
		reclaimtable(temp)
	else
		reclaimtable(self.RaidRoster)
 	end
end

function DOKarma:RemoveUnit(name)
	reclaimtable(self.RaidRoster[name])
	self.RaidRoster[name] = nil
end

function DOKarma:CreateOrUpdateUnit(UnitID)
	name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(UnitID)
	if name then
		if not self.RaidRoster[name] then
			self.RaidRoster[name] = getnewtable()
		end
		self.RaidRoster[name].Name = name
		self.RaidRoster[name].RaidID = UnitID
		self.RaidRoster[name].Class = class
		self.RaidRoster[name].UpperClass = fileName
		self.RaidRoster[name].Online = online
		self.RaidRoster[name].ColouredClassString = DOKarma:GetColoredTextByClass(class, class)
		self.RaidRoster[name].ColouredUpperClassString = DOKarma:GetColoredTextByClass(fileName, class)
		self.RaidRoster[name].ColouredNameString = DOKarma:GetColoredTextByClass(name, class)
		self.RaidRoster[name].ColouredPassNameString = DOKarma:GetColoredTextByClass(name.." (Pass)", class)

		return name
	else
		return
	end

end

--Start of functions for masterlooter modifications
function DOKarma:DOToggleDropDownMenu(level, value, dropDownFrame, anchorName, xOffset, yOffset, ...)
	if dropDownFrame and dropDownFrame == GroupLootDropDown and GetNumRaidMembers() > 0 and DOKarma:IsMasterLooter() and DOKarma.Settings.CanChangeNote and DOKarma.Settings.VersionUpToDate then
		DOKarma:ShowMenu(anchorName, xOffset, yOffset)
	else
		self.hooks.ToggleDropDownMenu(level, value, dropDownFrame, anchorName, xOffset, yOffset, ...)
	end
end

function DOKarma:ShowMenu(anchorName, xOffset, yOffset)
	local lootItemFrame = getglobal(anchorName)
	if lootItemFrame then	
		dewdrop:Open(
				lootItemFrame,
				'children', function(level, value) self:DOKLootItemMenu(level, value, lootItemFrame) end,
				'point', "TOPLEFT",
				'relativePoint', "BOTTOMLEFT"
		)
	end
end

function DOKarma:AssignToMe(lootItemFrame)
	for candidateNumber = 1, 40 do
		if (GetMasterLootCandidate(candidateNumber) == self.Settings.LocalPlayer) then
			GiveMasterLoot(lootItemFrame.slot, candidateNumber)
			return
		end
	end
end
--End of functions for masterlooter modifications

function DOKarma:CheckVersion()
	return self.version == self.Settings.CurrentAllowedVersion
end

function DOKarma:SetupGuildDefaults(DefaultRaidTimerLength, DefaultTimerPointAward, MaximumKarma, MinimumRank, AttendancePoints)
	local OrigGI = GetGuildInfoText()
	local NewGI
	_, _, Defaults = string.find(OrigGI, "(<DK/.+/>)")

	if Defaults then
		NewGI = string.gsub(OrigGI, "(<DK/.+/>)", "<DK/T:"..self.Settings.DefaultRaidTimerLength.."/P:"..self.Settings.DefaultTimerPointAward.."/V:"..self.version.."/M:"..self.Settings.MaximumKarma.."/MR:"..self.Settings.MinimumRank.."/AP:"..self.Settings.AttendancePoints.."/>")
		SetGuildInfoText(NewGI)
	else
		NewGI = OrigGI.."\n<DK/T:"..self.Settings.DefaultRaidTimerLength.."/P:"..self.Settings.DefaultTimerPointAward.."/V:"..self.version.."/M:"..self.Settings.MaximumKarma.."/MR:"..self.Settings.MinimumRank.."/AP:"..self.Settings.AttendancePoints.."/>"
		SetGuildInfoText(NewGI)
	end
	
end

function DOKarma:IsMasterLooter()
	local lootmethod, masterlooterID, IsMasterLooter
	lootmethod, masterlooterID = GetLootMethod()
	IsMasterLooter = false

	if lootmethod == 'master' and masterlooterID == 0 then
		IsMasterLooter = true
	end
	return IsMasterLooter	
end

function DOKarma:GetNewOfficerNote(currentnote, luck, warnings)
	if DOKarma:DONoteExists(currentnote) then
		local newnotestring, DOData
		_,_,DOData = string.find(currentnote,"(<DK/.+/>)")
		newnotestring = string.gsub(DOData,"/L:%d+/","/L:"..luck.."/")
		newnotestring = string.gsub(newnotestring,"/W:%d+/","/W:"..warnings.."/")
		return newnotestring
	else
		if currentnote then
			return "<DK/L:"..luck.."/W:"..warnings.."/>"..currentnote
		else
			return "<DK/L:"..luck.."/W:"..warnings.."/>"
		end
	end
end

function DOKarma:GetNoteData(note)
	if DOKarma:DONoteExists(note) then
		local luck, warnings, DOData, TL, TP, Ver
		_,_,DOData = string.find(note,"(<DK/.+/>)")
		_,_,luck = string.find(DOData,"/L:(%d+)/")
		_,_,warnings = string.find(DOData,"/W:(%d+)/")
		return tonumber(luck), tonumber(warnings)
	else
		return 0, 0
	end
end

function DOKarma:DONoteExists(data)
	local i,j,s
	
	if not data then
		return false
	end
	
	i,j,s = string.find(data,"(<DK/.+/>)")
	if s then
		return true
	else
		return false
	end
end

function DOKarma:CheckRollList(name)
	local exists = false
	for index,value in ipairs(self.KarmaRolls) do
		if name == value[1] then
			exists = true
		end
	end
	return exists
end

function DOKarma:MemberInGuild(name)
	if self.GuildRoster[name] then
		return true
	else
		return false
	end
end

function DOKarma:MemberIsOnline(name)
	if self.GuildRoster[name].Online then
		return true
	else
		return false
	end
end
-- End DOKarma Utility Functions and Checks


function DOKarma:PerformKarmaRollCheck(lootItemFrame)
	if (self:IsMasterLooter() or IsRaidOfficer()) and not self.Settings.IsActiveRoll then
		self.Settings.IsActiveRoll = true
		
		if lootItemFrame then
			local iteminfo = GetLootSlotLink(lootItemFrame.slot)
			DOKarma:SendDOChatMessage("If you NEED "..iteminfo.." ROLL NOW!  Karma will be used.", "RAID")
		else
			DOKarma:SendDOChatMessage("ROLL NOW!  Karma may or may not be used.", "RAID")
		end
		reclaimtable(self.KarmaRolls)
		self.KarmaRolls = nil
		self.KarmaRolls = getnewtable()

		self.frames.rollbutton:Show()
		self.frames.passbutton:Show()
		self.frames.main:Show()

		self:UpdateScrollBar()
		self:SendCommMessage("RAID", "ShowClientRollFrame")
	else
		DOKarma:Print("Roll session is already active or not master looter!")
	end
end

function DOKarma:UpdateInternalGuildRoster()
	local numGuildMembers = GetNumGuildMembers(true)
	local name, rank, rankIndex, level, class, zone, note, officernote, online, status
	local updated, updatestring

	updated = false

	DOKarma:GetConfigData()

	for i = 1, numGuildMembers, 1 do
		name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(i)
		local luck, warnings

		if DOKarma:DONoteExists(officernote) then
			luck, warnings = DOKarma:GetNoteData(officernote)
		else
			if self.Settings.CanChangeNote and self.Settings.VersionUpToDate then
				GuildRosterSetOfficerNote(i,DOKarma:GetNewOfficerNote(officernote, 0, 0))
			end
			luck = 0
			warnings = 0
		end

		if not self.GuildRoster[name] then
			self.GuildRoster[name] = {
				Name = name,
				Rank = rankIndex,
				Online = online,
				Luck = luck,
				Warnings = warnings,
				Modified = false,
				Class = class,
				Zone = zone,
				ColouredName = DOKarma:GetColoredTextByClass(name, class)
				}
		else
			if self.GuildRoster[name].Modified then
				if self.Settings.CanChangeNote and self.Settings.VersionUpToDate then
					updated = true
					if updatestring then
						updatestring = updatestring .. ", " .. self.GuildRoster[name].ColouredName
					else
						updatestring = self.GuildRoster[name].ColouredName
					end
					GuildRosterSetOfficerNote(i,DOKarma:GetNewOfficerNote(officernote, self.GuildRoster[name].Luck, self.GuildRoster[name].Warnings))
					self.GuildRoster[name].Modified = false
				end
			else
				self.GuildRoster[name].Warnings = warnings
				self.GuildRoster[name].Luck = luck
			end
			self.GuildRoster[name].Rank = rankIndex
			self.GuildRoster[name].Zone = zone
			self.GuildRoster[name].Online = online
		end
	end
	if updated == true then
		self:Print("Updated: "..updatestring)
	end
	self:Update()
end

function sortedpairs(t,comparator)
	local sortedKeys = {};
	table.foreach(t, function(k,v) table.insert(sortedKeys,k) end);
	table.sort(sortedKeys,comparator);
	local i = 0;
	local function _f(_s,_v)
		i = i + 1;
		local k = sortedKeys[i];
		if (k) then
			return k,t[k];
		end
	end
	return _f,nil,nil;
end


function DOKarma:TestFrameClick(name)
	for index,value in ipairs(self.KarmaRolls) do
		if name == value[1] then
			DOKarma:SendDOChatMessage(name.." has won with a roll of "..value[3].." ("..value[2].."+"..self.GuildRoster[name].Luck..")", "RAID")
			DOKarma:SendDOChatMessage("You have had your Karma points adjusted to: "..ceil(self.GuildRoster[name].Luck / 2), "WHISPER", name)

			self.GuildRoster[name].Luck = ceil(self.GuildRoster[name].Luck / 2)
			self.GuildRoster[name].Modified = true
			self.Settings.IsActiveRoll = false
			self.frames.main:Hide()
			self:SendCommMessage("RAID", "HideClientRollFrame")

		end
	end
end

function DOKarma:LookingForRolls(e)
	if not self.Settings.IsActiveRoll then return end

	local name, roll, low, high
	for name, roll, low, high in string.gmatch(e, "([^%s]+) rolls (%d+) %((%d+)%-(%d+)%)$") do

		if not self:CheckRollList(name) and not self:CheckRollList(name.." (Pass)") then
			low = tonumber(low)
			high = tonumber(high)
			roll = tonumber(roll)
			
			if low ~= 1 or high ~= 100 then
				DOKarma:SendDOChatMessage("You used invalid roll numbers. Roll ignored!", "WHISPER", name)
				return
			end

			if self.GuildRoster[name] and self.GuildRoster[name].Luck and self.GuildRoster[name].Rank <= self.Settings.MinRankToUseKarma then
				table.insert(self.KarmaRolls, {name, roll, self.GuildRoster[name].Luck + roll, self.RaidRoster[name].ColouredNameString, high, false})
				self:SendCommMessage("RAID", "RollForClientFrame", { name, roll, (self.GuildRoster[name].Luck + roll), low, high, "false" } )
			else
				table.insert(self.KarmaRolls, {name, roll, roll, self.RaidRoster[name].ColouredNameString, high, false})
				self:SendCommMessage("RAID", "RollForClientFrame", { name, roll, roll, low, high, "false" } )
			end

			self:Sort(self.KarmaRolls, 3)
			self:UpdateScrollBar()
		else
			DOKarma:SendDOChatMessage("You've already rolled.  Your roll has been discarded.", "WHISPER", name)
		end
    end
end

function DOKarma:DOToggleViewGuild(value)
    self.db.profile.DOViewGuild = not self.db.profile.DOViewGuild
end

function DOKarma:AddPoints(value, NeedSameZone)
	if value == 0 then return end

	local num = GetNumGuildMembers(true)

	local raidnum = GetNumRaidMembers()
	local ZoneName = GetRealZoneText()

	if NeedSameZone then
		DOKarma:SendDOChatMessage(self.Settings.LocalPlayer.." has awarded all raid members in "..ZoneName.." "..value.." Karma points", "RAID")
	else
		DOKarma:SendDOChatMessage(self.Settings.LocalPlayer.." has awarded the raid "..value.." Karma points", "RAID")
	end
	
	for i=1,40 do
		local name, zone, online
		name, _, _, _, _, _, zone, online, _ = GetRaidRosterInfo(i)
		if DOKarma:MemberInGuild(name) and online then
			if NeedSameZone then
				if not zone then zone = ZoneName end
				if zone == ZoneName then
					self.GuildRoster[name].Luck = self.GuildRoster[name].Luck + tonumber(value)
					if self.GuildRoster[name].Luck > self.Settings.MaxPoints then
						self.GuildRoster[name].Luck = self.Settings.MaxPoints
					end
					self.GuildRoster[name].Modified = true
				end
			else
				self.GuildRoster[name].Luck = self.GuildRoster[name].Luck + tonumber(value)
				if self.GuildRoster[name].Luck > self.Settings.MaxPoints then
					self.GuildRoster[name].Luck = self.Settings.MaxPoints
				end
				self.GuildRoster[name].Modified = true
			end
		end
	end

end

function DOKarma:AddPointsToName(charname, value)

	if DOKarma:MemberInGuild(charname) and DOKarma:MemberIsOnline(charname) and self.GuildRoster[charname] then
		self.GuildRoster[charname].Luck = self.GuildRoster[charname].Luck + tonumber(value)
		if self.GuildRoster[charname].Luck > self.Settings.MaxPoints then
			self.GuildRoster[charname].Luck = self.Settings.MaxPoints
		end
		self.GuildRoster[charname].Modified = true
	end

end

function DOKarma:InitGuildPoints(PointsToInitWith)
 local name, rank, rankIndex, level, class, zone, note, officernote, online, status
 local num = GetNumGuildMembers(true);

    for i = 1, num do
        GuildRosterSetOfficerNote(i,"<DK/L:"..PointsToInitWith.."/W:0/>")
    end
end

function DOKarma:RaidTimerTick()
	if UnitInRaid("player") and DOKarma.Settings.CanChangeNote and (IsRaidLeader() == 1 or IsRaidOfficer() == 1) then
		DOKarma:AddPoints(DOKarma.Settings.RaidTimerPoints)
	else
		self:CancelScheduledEvent(DOKarma.Settings.TimerName)
		DOKarma.Settings.RaidTimerActivated = false
	end
end

function DOKarma:IsRaidTimer()
    return DOKarma.Settings.RaidTimerActivated
end

function DOKarma:ToggleTimer()
    if self.Settings.RaidTimerActivated then
		self:CancelScheduledEvent(self.Settings.TimerName)
		self.Settings.RaidTimerActivated = not self.Settings.RaidTimerActivated
		self:SendCommMessage("RAID", "TimerStarted", "false")
    else
		if self.Settings.RaidTimerInterval == 0 then
			self:Print("Timer Interval set to 0.  Timer not enabled.")
			return
		end
		if not self.Settings.RaidTimerStarted then
			self:ScheduleRepeatingEvent(self.Settings.TimerName, self.RaidTimerTick, self.Settings.RaidTimerInterval * 60)
			self.Settings.RaidTimerActivated = not self.Settings.RaidTimerActivated
			self:SendCommMessage("RAID", "TimerStarted", "true")
		else
			self:Print("A raid timer is already active. Started by: "..self.Settings.RaidTimerStarter)
		end
    end
end

function DOKarma:ToggleSortByName()
	self.db.profile.SortByName = not self.db.profile.SortByName
end

function DOKarma:ToggleDisplayLocation()
	self.db.profile.DisplayLocation = not self.db.profile.DisplayLocation
end

function DOKarma:SendDOChatMessage(msg, msgtype, name)
	if msgtype == "RAID" then
		SendChatMessage(msg, "RAID")
	elseif msgtype == "WHISPER" then
		SendChatMessage(msg, "WHISPER", nil, name)
	end
end

function DOKarma:OnTooltipUpdate()

	if self.Settings.IsInitialised then
		if not self.Settings.FeaturesInactive then
			if not self.Settings.VersionUpToDate then
				local cat = tablet:AddCategory(
					"columns", 1,
					"text", "Karma Mod out of date.  Please update.",
					'showWithoutChildren', true
				)
			end

			if self.db.profile.DisplayLocation then
				local cat = tablet:AddCategory(
					"columns", 3,
					"text", "Name",
					"text2", "Location",
					"text3", "Karma"
				)

				if self.db.profile.SortByName then
					for k,v in sortedpairs(self.GuildRoster) do
						if v.Online then
							cat:AddLine(
								"text",v.ColouredName,
								"text2",v.Zone,
								"text3",v.Luck,
								'justify', "LEFT",
								'justify2', "LEFT",
								'justify3', "RIGHT"
							)
						end
					end
				else
					for k,v in sortedpairs(self.GuildRoster, function(a,b) return self.GuildRoster[a].Luck < self.GuildRoster[b].Luck end ) do
						if v.Online then
							cat:AddLine(
								"text",v.ColouredName,
								"text2",v.Zone,
								"text3",v.Luck,
								'justify', "LEFT",
								'justify2', "LEFT",
								'justify3', "RIGHT"
							)
						end
					end
				end

			else
				local cat = tablet:AddCategory(
					"columns", 2,
					"text", "Name",
					"text2", "Karma"
				)

				if self.db.profile.SortByName then
					for k,v in sortedpairs(self.GuildRoster) do
						if v.Online then
							cat:AddLine(
								"text",v.ColouredName,
								"text2",v.Luck
							)
						end
					end
				else
					for k,v in sortedpairs(self.GuildRoster, function(a,b) return self.GuildRoster[a].Luck < self.GuildRoster[b].Luck end ) do
						if v.Online then
							cat:AddLine(
								"text",v.ColouredName,
								"text2",v.Luck
							)
						end
					end
				end

			end


		else
			local cat = tablet:AddCategory(
				"columns", 1,
				"text", "Karma Mod Disabled",
				'showWithoutChildren', true
			)

			if not self.Settings.IsInGuild then
				cat:AddLine(
				'text', "Not in guild."
				)
			else
				cat:AddLine(
				'text', "No defaults found in guild info."
				)
			end
		end
	else
		local cat = tablet:AddCategory(
			"columns", 1,
			"text", "Karma Mod Initialising. Please Wait.",
			'showWithoutChildren', true
		)
	end
	
end

function DOKarma:Sort(tbl, sortBy)
	if( sortBy == 1 ) then
		table.sort(tbl,
			function(t1, t2)
				if (t1[sortBy] == t2[sortBy] ) then
					return t1[1] > t2[1]
				else
					return t1[sortBy] < t2[sortBy]
				end
			end
		)
	else
		table.sort(tbl,
			function(t1, t2)
				if (t1[sortBy] == t2[sortBy] ) then
					return t1[1] < t2[1]
				else
					return t1[sortBy] > t2[sortBy]
				end
			end
		)
	end
end



