
function DOKarma:OnMenuRequest(level, value, inTooltip)

	if level == 1 then

		dewdrop:AddLine()

		if self.Settings.IsInGuild then
			if self.Settings.LocalPlayerGuildRank == 0 then
				dewdrop:AddLine(
				'text', 'DOKarma Initialisation Options',
				'isTitle', true
				)

				dewdrop:AddLine(
				"text","Initialisation Settings",
				"hasArrow", true,
				"value", "InitSettings",
				'tooltipTitle', "Init Settings",
				'tooltipText', "Options for guild leaders to setup DOKarma"
				)
				dewdrop:AddLine()
			end
		end

		--self.Settings.FeaturesInactive

		if not self.Settings.IsInitialised then
			--if not self.Settings.IsInGuild then
			dewdrop:AddLine(
			'text', "Please wait.  DOKarma Initialising."
			)
			--end

		
--~ 			if not self.Settings.IsInGuild then
--~ 				dewdrop:AddLine(
--~ 				'text', "Not in Guild.  DOKarma Disabled."
--~ 				)
--~ 			end
--~ 			if not self.Settings.DefaultsFound then
--~ 				dewdrop:AddLine(
--~ 				'text', "No defaults found.  DOKarma Disabled."
--~ 				)
--~ 			end

		else
		
			if self.Settings.FeaturesInactive then
				dewdrop:AddLine(
				'text', "Features disabled."
				)
				
				if self.Settings.IsInGuild == false then
					dewdrop:AddLine(
					'text', "Not in a guild."
					)
				else
					dewdrop:AddLine(
					'text', "Defaults not found in guild info."
					)
				end

			else
		
				if not self.Settings.VersionUpToDate then
					if self.Settings.CanChangeNote then
						dewdrop:AddLine(
						'text', "Version Mismatch. Officer features Disabled."
						)
					else
						dewdrop:AddLine(
						'text', "Version Mismatch. Please update mod when possible."
						)
					end
				end

				local RaidMembers = GetNumRaidMembers()

				if self.Settings.CanChangeNote then

					dewdrop:AddLine(
					'text', 'Guild Officer Features',
					'isTitle', true
					)

					dewdrop:AddLine(
					"text","Check Addons",
					"hasArrow", true,
					"value", "CheckAddon",
					'tooltipTitle', "Check Addons",
					'tooltipText', "Allows Officers to check the addons that guild members have"
					)

					dewdrop:AddLine()

				end

				if RaidMembers > 0 and self.Settings.CanChangeNote and (IsRaidLeader() == 1 or IsRaidOfficer() == 1) and self.Settings.VersionUpToDate then

					dewdrop:AddLine(
					'text', 'Raid Officer Features',
					'isTitle', true
					)

					dewdrop:AddLine(
					'text', "Timer Length (mins): "..self.Settings.RaidTimerInterval,
					'textR', 0,
					'textG', 1,
					'textB', 1,
					'tooltipTitle', "Raid Timer Length",
					'tooltipText', "Values from guild defaults."
					)

					dewdrop:AddLine(
					'text', "Points/Timer Tick: "..self.Settings.RaidTimerPoints,
					'textR', 0,
					'textG', 1,
					'textB', 1,
					'tooltipTitle', "Raid Timer Points",
					'tooltipText', "Values from guild defaults."
					)

					dewdrop:AddLine(
					"text","Award Points to Raid",
					"hasArrow", true,
					"value", "AddRP",
					'tooltipTitle', "Award Points",
					'tooltipText', "Options for awarding or removing points from raid members"
					)

					dewdrop:AddLine(
					'text', "Toggle Raid Timer",
					'checked',  self.Settings.RaidTimerActivated,
					'arg1',self,
					'func', "ToggleTimer",
					'tooltipTitle', "Turn Timer on or off",
					'tooltipText', "Starts or stops the Raid Timer"
					)

					dewdrop:AddLine(
					"text","Start Roll",
					"func",function() DOKarma:PerformKarmaRollCheck() end,
					'tooltipTitle', "Start Roll",
					'tooltipText', "Starts a generic DOKarma roll",
					'closeWhenClicked', true
					)

					dewdrop:AddLine()
				end            
			end
		end
		
		if self.Settings.IsInitialised and not self.Settings.FeaturesInactive then

			dewdrop:AddLine(
			'text', 'DOKarma Client Options',
			'isTitle', true
			)

			dewdrop:AddLine(
			'text', "Toggle Sort By Name",
			'checked',  self.db.profile.SortByName,
			'arg1',self,
			'func', "ToggleSortByName",
			'tooltipTitle', "Display by Name or Points",
			'tooltipText', "Toggles sorting display by name or points."
			)

			dewdrop:AddLine(
			'text', "Display Location",
			'checked',  self.db.profile.DisplayLocation,
			'arg1',self,
			'func', "ToggleDisplayLocation",
			'tooltipTitle', "Display Location",
			'tooltipText', "Toggles viewing of location."
			)
		end

		dewdrop:AddLine()

		dewdrop:AddLine(
		'text', 'FuBar Plugin Options',
		'isTitle', true
		)
		
        elseif level == 2 then

			if value == "InitSettings" then
				dewdrop:AddLine(
				'text', 'DOKarma Initialisation Options',
				'isTitle', true
				)

				dewdrop:AddLine(
				'text', "Please be careful in the section. Initialisation",
				'textR', 0,
				'textG', 1,
				'textB', 1,
				'isTitle', true
				)
				dewdrop:AddLine(
				'text', "does not ask for confirmation. Use with care.",
				'textR', 0,
				'textG', 1,
				'textB', 1,
				'isTitle', true
				)


			dewdrop:AddLine(
				"text","Initialise Guild with "..self.Settings.InitialisationPoints.." Points",
				"func",function() DOKarma:InitGuildPoints(self.Settings.InitialisationPoints) end,
				'tooltipTitle', "Initialises the guild",
				'tooltipText', "This resests the karma of all guild members."
				)

				dewdrop:AddLine(
				'text', "Init Points",
				"hasArrow",true,
				"hasSlider",true,
				"sliderMin",0,
				"sliderMax",100,
				"sliderValue", self.Settings.InitialisationPoints,
				"sliderFunc", function(value) self.Settings.InitialisationPoints = ceil(value) return ceil(value) end,
				'tooltipTitle', "Init Points",
				'tooltipText', "Points to initialise with."
				)

				dewdrop:AddLine()

				dewdrop:AddLine(
				"text","Setup/Update Guild Defaults",
				"func",function() DOKarma:SetupGuildDefaults() end,
				'tooltipTitle', "Guild Defaults",
				'tooltipText', "This will update the guild defaults stored in the guild info."
				)

				dewdrop:AddLine(
				'text', "Default Raid Timer Length (mins)",
				"hasArrow",true,
				"hasSlider",true,
				"sliderMin",0,
				"sliderMax",120,
				"sliderValue", self.Settings.DefaultRaidTimerLength,
				"sliderFunc", function(value) self.Settings.DefaultRaidTimerLength = ceil(value) return ceil(value) end,
				'tooltipTitle', "Raid Timer Length",
				'tooltipText', "The default raid timer length.  Remember to update the guild defaults when changing this."
				)
				
				dewdrop:AddLine(
				'text', "Default Timer Point Award",
				"hasArrow",true,
				"hasSlider",true,
				"sliderMin",0,
				"sliderMax",10,
				"sliderValue", self.Settings.DefaultTimerPointAward,
				"sliderFunc", function(value) self.Settings.DefaultTimerPointAward = ceil(value) return ceil(value) end,
				'tooltipTitle', "Raid Timer Points",
				'tooltipText', "The default raid timer points.  Remember to update the guild defaults when changing this."
				)

				dewdrop:AddLine(
				'text', "Maximum Karma",
				"hasArrow",true,
				"hasSlider",true,
				"sliderMin",0,
				"sliderMax",1000,
				"sliderValue", self.Settings.MaximumKarma,
				"sliderFunc", function(value) self.Settings.MaximumKarma = ceil(value) return ceil(value) end,
				'tooltipTitle', "Maximum Karma",
				'tooltipText', "The default max karma amount.  Remember to update the guild defaults when changing this."
				)

				dewdrop:AddLine(
				'text', "Minimum Rank To Use Points",
				"hasArrow",true,
				"hasSlider",true,
				"sliderMin",0,
				"sliderMax",10,
				"sliderValue", self.Settings.MinimumRank,
				"sliderFunc", function(value) self.Settings.MinimumRank = ceil(value) return ceil(value) end,
				'tooltipTitle', "Minimum Rank",
				'tooltipText', "Allows the guild to have a trial rank that can earn, but not spend points.  Remember to update the guild defaults when changing this."
				)

				dewdrop:AddLine(
				'text', "Attendance Points Awarded",
				"hasArrow",true,
				"hasSlider",true,
				"sliderMin",0,
				"sliderMax",10,
				"sliderValue", self.Settings.AttendancePoints,
				"sliderFunc", function(value) self.Settings.AttendancePoints = ceil(value) return ceil(value) end,
				'tooltipTitle', "Attendance Points",
				'tooltipText', "The default attendance point award.  Remember to update the guild defaults when changing this."
				)

			end

            if value == "CheckAddon" then

                dewdrop:AddLine(
                "text","Check Addons",
				"checked", false,
                "func",function()
					DOKarma:DoAddonCheck()
				end,
				'closeWhenClicked', true,
				'tooltipTitle', "Addon Check",
				'tooltipText', "Checks the addons that guild members have running."
                )

                dewdrop:AddLine(
                "text","Addon1"
				,'hasArrow', true
				,'hasEditBox', true
				,'editBoxText', self.db.profile.AddonList[1]
				,'editBoxFunc', function(text)
					self.db.profile.AddonList[1] = text
				end,
				'tooltipTitle', "Addon to Check",
				'tooltipText', "Type addon name and press enter to save."
				)

                dewdrop:AddLine(
                "text","Addon2"
				,'hasArrow', true
				,'hasEditBox', true
				,'editBoxText', self.db.profile.AddonList[2]
				,'editBoxFunc', function(text)
					self.db.profile.AddonList[2] = text
				end,
				'tooltipTitle', "Addon to Check",
				'tooltipText', "Type addon name and press enter to save."
				)

                dewdrop:AddLine(
                "text","Addon3"
				,'hasArrow', true
				,'hasEditBox', true
				,'editBoxText', self.db.profile.AddonList[3]
				,'editBoxFunc', function(text)
					self.db.profile.AddonList[3] = text
				end,
				'tooltipTitle', "Addon to Check",
				'tooltipText', "Type addon name and press enter to save."
				)

                dewdrop:AddLine(
                "text","Addon4"
				,'hasArrow', true
				,'hasEditBox', true
				,'editBoxText', self.db.profile.AddonList[4]
				,'editBoxFunc', function(text)
					self.db.profile.AddonList[4] = text
				end,
				'tooltipTitle', "Addon to Check",
				'tooltipText', "Type addon name and press enter to save."
				)

                dewdrop:AddLine(
                "text","Addon5"
				,'hasArrow', true
				,'hasEditBox', true
				,'editBoxText', self.db.profile.AddonList[5]
				,'editBoxFunc', function(text)
					self.db.profile.AddonList[5] = text
				end,
				'tooltipTitle', "Addon to Check",
				'tooltipText', "Type addon name and press enter to save."
				)

				end

            if value == "AddRP" then
			
				dewdrop:AddLine(
				'text', "Attendance Points: "..self.Settings.AttendancePoints,
				'textR', 0,
				'textG', 1,
				'textB', 1,
				'tooltipTitle', "Attendance Points",
				'tooltipText', "Values from guild defaults."
				)

                dewdrop:AddLine(
                "text","Add Raid Attendance/Ontime Point",
				"checked", false,
                "func",function() DOKarma:AddPoints(self.Settings.AttendancePoints, true) end,
				'tooltipTitle', "Award Attendance Points",
				'tooltipText', "All raid members in the same location as you will be awarded "..self.Settings.AttendancePoints.." point/s."
                )

				dewdrop:AddLine()

			
                dewdrop:AddLine(
                "text","Add 1 Point",
				"checked", false,
                "func",function() DOKarma:AddPoints(1) end,
				'tooltipTitle', "Award Points",
				'tooltipText', "Awards points to current raid members."
                )
                dewdrop:AddLine(
                "text","Add 3 Points",
				"checked", false,
                "func",function() DOKarma:AddPoints(3) end,
				'tooltipTitle', "Award Points",
				'tooltipText', "Awards points to current raid members."
                )
                dewdrop:AddLine(
                "text","Add 5 Points",
				"checked", false,
                "func",function() DOKarma:AddPoints(5) end,
				'tooltipTitle', "Award Points",
				'tooltipText', "Awards points to current raid members."
                )

				dewdrop:AddLine()

                dewdrop:AddLine(
                "text","Remove 1 Point",
				"checked", false,
                "func",function() DOKarma:AddPoints(-1) end,
				'tooltipTitle', "Remove Points",
				'tooltipText', "Removes points from current raid members."
                )
                dewdrop:AddLine(
                "text","Remove 3 Points",
				"checked", false,
                "func",function() DOKarma:AddPoints(-3) end,
				'tooltipTitle', "Remove Points",
				'tooltipText', "Removes points from current raid members."
                )
                dewdrop:AddLine(
                "text","Remove 5 Points",
				"checked", false,
                "func",function() DOKarma:AddPoints(-5) end,
				'tooltipTitle', "Remove Points",
				'tooltipText', "Removes points from current raid members."
                )

				dewdrop:AddLine()

				dewdrop:AddLine(
				'text', "Custom Points",
				"hasArrow",true,
				"hasSlider",true,
				"sliderMin",-20,
				"sliderMax",20,
				"sliderValue", self.Settings.RaidCustomPoints,
				"sliderFunc", function(value) self.Settings.RaidCustomPoints = ceil(value) return ceil(value) end,
				'tooltipTitle', "Custom Points",
				'tooltipText', "Sets the amount of custom points to add or remove."				)

                dewdrop:AddLine(
                "text","Add/Remove Custom Points ("..self.Settings.RaidCustomPoints..")",
				"checked", false,
                "func",function() DOKarma:AddPoints(self.Settings.RaidCustomPoints) end,
				'tooltipTitle', "Add/Remove Points",
				'tooltipText', "Adds/Removes points to/from current raid members."
                )
				end
        end


	self:Update()
end

function DOKarma:DOKLootItemMenu(level, value, Extra)

	if level == 1 then
		dewdrop:AddLine(
				'text', "DOKarma Master Looter",
				'isTitle', true
			)
		dewdrop:AddLine(
			"text","Start Karma Roll",
			"checked", false,
			"func",function() DOKarma:PerformKarmaRollCheck(Extra) end
			)
		
		dewdrop:AddLine()

		local Classes = {}
			
		for candidateNumber = 1, 40 do
			local candidate = GetMasterLootCandidate(candidateNumber)
			if candidate then
				if not Classes[self.RaidRoster[candidate].Class] then
					Classes[self.RaidRoster[candidate].Class] = true
					dewdrop:AddLine(
						"text" , self.RaidRoster[candidate].ColouredClassString,
						"value", self.RaidRoster[candidate].Class,
						"hasArrow", true
					)
				end
			end
		end
		
		dewdrop:AddLine()

		dewdrop:AddLine(
		"text","Assign to Self",
		"checked", false,
		"func",function()
			DOKarma:AssignToMe(Extra)
			dewdrop:Close()
		end
		)
		
	end

	if level == 2 then
		for candidateNumber = 1, 40 do
			local candidate = GetMasterLootCandidate(candidateNumber)
			if candidate then
				local cNumber = candidateNumber
				if value == self.RaidRoster[candidate].Class then
					dewdrop:AddLine(
						"text", candidate,
						"func", function()
									GiveMasterLoot(Extra.slot, cNumber)
									dewdrop:Close()
								end
					)
				end
			end
		end
	end

	
end
